#NoTrayIcon
#AutoIt3Wrapper_Res_Comment=Created by: Micha Morawski (aka moras86)
#AutoIt3Wrapper_Res_Description=Desktop app to control Samsung B-series HDTV via LAN.
#AutoIt3Wrapper_Res_LegalCopyright=SamyGO.tv  2011-2012
#AutoIt3Wrapper_Res_Field=ProductName|Remote LAN Control - Desktop app
#AutoIt3Wrapper_Res_Field=ProductVersion|%AutoItVer% (AutoIt)
#AutoIt3Wrapper_Res_Field=CompanyName|SamyGO  2011-2012
#AutoIt3Wrapper_Res_Fileversion=0.8.0.45
#AutoIt3Wrapper_Outfile=Remote LAN Control.exe
#AutoIt3Wrapper_Icon=include\icon.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UPX_Parameters=--ultra-brute

#cs ----------------------------------------
 AutoIt: 3.3.8.0
 Author: moras86
 Function: Remote LAN Control - Samsung HDTV
 Version: 0.8
#ce ----------------------------------------

#Include <GUIConstantsEx.au3>
#Include <GUIStatusBar.au3>
#Include <StaticConstants.au3>
#Include <WindowsConstants.au3>
#Include <ComboConstants.au3>
#Include "include\Restart.au3"
#Include "include\GUIIPAddress_light.au3"
#Include "include\WinAPIEx_light.au3"

Global $cnt_www=1000,$cnt_forum=1000,$cnt_tv_app=1000,$cnt_pc_app=1000,$cnt_about,$cnt_config,$cnt_buttons,$config_box,$tray_restore,$tray_exit,$menu_config,$menu_exit, _
 $menu_show_status,$menu_hotkeys_numeric,$menu_hotkeys_arrows,$menu_hotkeys_media,$menu_soap,$menu_minimize,$menu_about,$menu_b650_938,$menu_b650_861,$menu_b6000, _
 $menu_a956,$menu_fast_btn,$menu_buttons,$menu_tv_app,$menu_pc_app,$menu_forum,$menu_www,$menu_run,$menu_app1,$menu_app2,$menu_app3,$menu_app4,$menu_app5,$menu_app6, _
 $menu_app7,$menu_app8,$menu_app9,$menu_app10, _
 $btn_power,$btn_tv,$btn_1,$btn_2,$btn_3,$btn_1e,$btn_2e,$btn_3e,$btn_4,$btn_5,$btn_6,$btn_4e,$btn_5e,$btn_6e,$btn_7,$btn_8,$btn_9,$btn_7e,$btn_8e,$btn_9e,$btn_0,$btn_0e, _
 $btn_favch,$btn_prech,$btn_volup,$btn_mute,$btn_chup,$btn_voldn,$btn_source,$btn_chdn,$btn_info,$btn_menu,$btn_guide,$btn_tools,$btn_return,$btn_enter,$btn_up,$btn_left, _
 $btn_right,$btn_down,$btn_internet,$btn_exit,$btn_red,$btn_green,$btn_yellow,$btn_blue,$btn_ttx,$btn_media,$btn_content,$btn_chlist,$btn_ad,$btn_subt,$btn_fb,$btn_pause, _
 $btn_ff,$btn_rec,$btn_play,$btn_stop,$btn_srs,$btn_sleep,$btn_pip,$btn_pip1,$btn_pip2,$btn_energy,$btn_pmode,$btn_dynamic,$btn_standard,$btn_movie,$btn_smode,$btn_psize, _
 $btn_asp43,$btn_asp169,$btn_scart1,$btn_scart2,$btn_hdmi1,$btn_hdmi2,$btn_hdmi3,$btn_hdmi4,$btn_module,$btn_vga,$btn_av,$btn_dvb,$btn_hnc,$btn_dma,$btn_infol,$btn_pip_x, _
 $btn_space,$btn_dual,$btn_spk,$btn_emode,$btn_wlink,$btn_source_tv,$btn_source_vcr,$btn_source_dvd,$btn_source_stb,$btn_user_seq,$btn_test_send, _
 $btn_soap_refresh,$btn_soap_set_volume,$btn_soap_volume_mute,$input_soap_volume,$btn_soap_set_brightness,$input_soap_brightness,$btn_soap_play, _
 $btn_soap_set_contrast,$input_soap_contrast,$btn_soap_set_sharpness,$input_soap_sharpness,$btn_soap_set_colortemp,$input_soap_colortemp,$btn_soap_setall
Dim $iLastTab=0,$objHTTP,$strEnvelope,$strReturn,$objReturn,$dblTax,$strQuery,$oMyError

$version = "0.8"

; READ CONFIGURATION --------------------------------------
$config = @ScriptDir & "\config.ini"
$tv_ip				= IniRead($config, "connect", "ip", "0.0.0.0")
$tv_model			= IniRead($config, "model", "tv", "B650")
$tv_remote			= IniRead($config, "model", "rc", "938")
$user_btn			= IniRead($config, "user button", "active", "0")
$user_box_name		= IniRead($config, "user button", "box name", "")
$user_btn_name1		= IniRead($config, "user button", "name1", "")
$user_btn_keycode1	= IniRead($config, "user button", "keycode1", "")
$user_btn_name2		= IniRead($config, "user button", "name2", "")
$user_btn_keycode2	= IniRead($config, "user button", "keycode2", "")
$user_btn_seq		= IniRead($config, "user button", "seq", "0")
$user_btn_name		= IniRead($config, "user button", "name", "")
$user_btn_key1		= IniRead($config, "user button", "key1", "")
$user_btn_key2		= IniRead($config, "user button", "key2", "")
$user_btn_key3		= IniRead($config, "user button", "key3", "")
$user_btn_key4		= IniRead($config, "user button", "key4", "")
$user_btn_key5		= IniRead($config, "user button", "key5", "")
$user_btn_key6		= IniRead($config, "user button", "key6", "")
$user_btn_key7		= IniRead($config, "user button", "key7", "")
$user_btn_key8		= IniRead($config, "user button", "key8", "")
$user_btn_key9		= IniRead($config, "user button", "key9", "")
$user_btn_key0		= IniRead($config, "user button", "key0", "")
$source_scart1		= IniRead($config, "direct source", "scart1", "")
$source_scart2		= IniRead($config, "direct source", "scart2", "")
$source_module		= IniRead($config, "direct source", "module", "")
$source_av			= IniRead($config, "direct source", "av", "")
$source_vga			= IniRead($config, "direct source", "vga", "")
$source_hdmi1		= IniRead($config, "direct source", "hdmi1", "")
$source_hdmi2		= IniRead($config, "direct source", "hdmi2", "")
$source_hdmi3		= IniRead($config, "direct source", "hdmi3", "")
$source_hdmi4		= IniRead($config, "direct source", "hdmi4", "")
$hotkeys_numeric	= IniRead($config, "hotkeys", "numeric", "1")
$hotkeys_arrows		= IniRead($config, "hotkeys", "arrows", "1")
$hotkeys_media		= IniRead($config, "hotkeys", "media", "1")
$extra_buttons		= IniRead($config, "extra buttons", "visible", "1")
$app_cl				= IniRead($config, "content library", "active", "0")
$app_cl_new			= IniRead($config, "content library", "unofficial", "0")
$app_list1			= IniRead($config, "content library", "list_SamyGO", "Remote LAN Control")
$app_list2			= IniRead($config, "content library", "list_nurisam", "WiseStar")
$app1				= IniRead($config, "content library", "app1", "")
$app1				= IniRead($config, "content library", "app1", "")
$app1_x				= IniRead($config, "content library", "app1_x", "0")
$app1_a				= IniRead($config, "content library", "app1_a", "0")
$app2				= IniRead($config, "content library", "app2", "")
$app2_x				= IniRead($config, "content library", "app2_x", "0")
$app2_a				= IniRead($config, "content library", "app2_a", "0")
$app3				= IniRead($config, "content library", "app3", "")
$app3_x				= IniRead($config, "content library", "app3_x", "0")
$app3_a				= IniRead($config, "content library", "app3_a", "0")
$app4				= IniRead($config, "content library", "app4", "")
$app4_x				= IniRead($config, "content library", "app4_x", "0")
$app4_a				= IniRead($config, "content library", "app4_a", "0")
$app5				= IniRead($config, "content library", "app5", "")
$app5_x				= IniRead($config, "content library", "app5_x", "0")
$app5_a				= IniRead($config, "content library", "app5_a", "0")
$app6				= IniRead($config, "content library", "app6", "")
$app6_x				= IniRead($config, "content library", "app6_x", "0")
$app6_a				= IniRead($config, "content library", "app6_a", "0")
$app7				= IniRead($config, "content library", "app7", "")
$app7_x				= IniRead($config, "content library", "app7_x", "0")
$app7_a				= IniRead($config, "content library", "app7_a", "0")
$app8				= IniRead($config, "content library", "app8", "")
$app8_x				= IniRead($config, "content library", "app8_x", "0")
$app8_a				= IniRead($config, "content library", "app8_a", "0")
$app9				= IniRead($config, "content library", "app9", "")
$app9_x				= IniRead($config, "content library", "app9_x", "0")
$app9_a				= IniRead($config, "content library", "app9_a", "0")
$app10				= IniRead($config, "content library", "app10", "")
$app10_x			= IniRead($config, "content library", "app10_x", "0")
$app10_a			= IniRead($config, "content library", "app10_a", "0")
$fast_btn			= IniRead($config, "other", "fast_btn", "0")
$info_ch			= IniRead($config, "other", "info_ch", "0")
$alt_dvb			= IniRead($config, "other", "alt_dvb", "0")
$hide_menu			= IniRead($config, "other", "menu", "0")
$hide_status		= IniRead($config, "other", "status", "0")
$symbols			= IniRead($config, "other", "symbols", "0")
$optimize			= IniRead($config, "other", "optimize_mem", "0")
$tv_app				= IniRead($config, "link", "tv_app", "")
$pc_app				= IniRead($config, "link", "pc_app", "")
$forum				= IniRead($config, "link", "forum", "")
; READ CONFIGURATION ---------------------------------- end

; MAIN WINDOW ---------------------------------------------
$width=450
$height=655
$name="Remote LAN Control :: Samsung"
If $tv_model <> "" Then
	If $tv_model = "B650" Or $tv_model = "A956" Then
		If $extra_buttons = "1" Then
			$width=450
		ElseIf $extra_buttons = "0" Then
			$width=280
			$name="Remote LAN Control v" & $version
		EndIf
	ElseIf $tv_model = "SOAP" Then
		$width=400
		$height=300
	ElseIf $tv_model = "B6000" Then
		$width=280
		$name="Remote LAN Control v" & $version
	EndIf
EndIf
If $hide_menu = "1" Or $hide_status = "1" Then
	$height=635
	If $tv_model = "SOAP" Then $height=280
EndIf
If $hide_menu = "1" And $hide_status = "1" Then
	$height=615
	If $tv_model = "SOAP" Then $height=260
EndIf
$btn_width=50
If $fast_btn = "0" Then	$btn_width=60

$GUI = GUICreate($name, $width, $height)

GUISetIcon("include\icon.ico", 0)
GUISetOnEvent($GUI_EVENT_CLOSE,	"end")
If $tv_model <> "SOAP" Then
	GUISetBkColor(0xFFFFFF)
	GUICtrlCreatePic(@ScriptDir & "\include\bg.jpg",   0,  10, 280, 600)
EndIf
GUICtrlSetState(-1, $GUI_DISABLE)

If $hide_menu <> "1" Then
	$menu_file = GUICtrlCreateMenu("File")
		$menu_minimize = GUICtrlCreateMenuItem("Minimize to tray", $menu_file)
		$menu_upnp_devices = GUICtrlCreateMenuItem("Show UPnP devices list", $menu_file)
		GUICtrlCreateMenuItem("", $menu_file)
		$menu_exit = GUICtrlCreateMenuItem("Exit", $menu_file)
	$menu_options = GUICtrlCreateMenu("Options")
		$menu_config = GUICtrlCreateMenuItem("Configuration", $menu_options)
		GUICtrlCreateMenuItem("", $menu_options)
		$menu_hotkeys = GUICtrlCreateMenu("Hotkeys", $menu_options)
			$menu_hotkeys_numeric = GUICtrlCreateMenuItem("Numeric hotkeys", $menu_hotkeys)
			If $hotkeys_numeric = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
			$menu_hotkeys_arrows = GUICtrlCreateMenuItem("Arrows and Enter key", $menu_hotkeys)
			If $hotkeys_arrows = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
			$menu_hotkeys_media = GUICtrlCreateMenuItem("Multimedia keyboard hotkeys", $menu_hotkeys)
			If $hotkeys_media = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
	$menu_view = GUICtrlCreateMenu("View")
		$menu_remote = GUICtrlCreateMenu("Remote scheme", $menu_view)
			$menu_b650 = GUICtrlCreateMenu("B650", $menu_remote)
				$menu_b650_938 = GUICtrlCreateMenuItem("BN59-00938A", $menu_b650)
				$menu_b650_861 = GUICtrlCreateMenuItem("BN59-00861A", $menu_b650)
			$menu_b6000 = GUICtrlCreateMenuItem("B6000", $menu_remote)
			$menu_a956 = GUICtrlCreateMenuItem("A956", $menu_remote)
			GUICtrlCreateMenuItem("", $menu_remote)
			$menu_soap = GUICtrlCreateMenuItem("universal (SOAP mode)", $menu_remote)
		GUICtrlCreateMenuItem("", $menu_view)
		If $tv_model = "B650" Or $tv_model = "A956" Then
			If $extra_buttons = "1" Then
				$menu_buttons = GUICtrlCreateMenuItem("Hide extra buttons panel", $menu_view)
			ElseIf $extra_buttons = "0" Then
				$menu_buttons = GUICtrlCreateMenuItem("Show extra buttons panel", $menu_view)
			EndIf
		Else
			$menu_buttons = GUICtrlCreateMenuItem("Show extra buttons panel", $menu_view)
			GUICtrlSetState(-1, $GUI_DISABLE)
		EndIf
		$menu_view_other = GUICtrlCreateMenu("Other", $menu_view)
			$menu_fast_btn = GUICtrlCreateMenuItem("Show buttons for fast channel switch", $menu_view_other)
			If $fast_btn = "1" Then	GUICtrlSetState(-1, $GUI_CHECKED)
			If $tv_model = "SOAP" Then GUICtrlSetState(-1, $GUI_DISABLE)
			$menu_show_status = GUICtrlCreateMenuItem("Show status bar", $menu_view_other)
			If $hide_status = "0" Then GUICtrlSetState(-1, $GUI_CHECKED)
	$menu_run = GUICtrlCreateMenu("Run")
	If $app_cl <> "1" Or $tv_model = "A956" Then GUICtrlSetState(-1, $GUI_DISABLE)
	If $app1 <> "" Then
		$menu_app1 = GUICtrlCreateMenuItem($app1, $menu_run)
		If $app1_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app2 <> "" Then
		$menu_app2 = GUICtrlCreateMenuItem($app2, $menu_run)
		If $app2_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app3 <> "" Then
		$menu_app3 = GUICtrlCreateMenuItem($app3, $menu_run)
		If $app3_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
		If $app4 <> "" Then
		$menu_app4 = GUICtrlCreateMenuItem($app4, $menu_run)
		If $app4_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app5 <> "" Then
		$menu_app5 = GUICtrlCreateMenuItem($app5, $menu_run)
		If $app5_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app6 <> "" Then
		$menu_app6 = GUICtrlCreateMenuItem($app6, $menu_run)
		If $app6_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app7 <> "" Then
		$menu_app7 = GUICtrlCreateMenuItem($app7, $menu_run)
		If $app7_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app8 <> "" Then
		$menu_app8 = GUICtrlCreateMenuItem($app8, $menu_run)
		If $app8_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app9 <> "" Then
		$menu_app9 = GUICtrlCreateMenuItem($app9, $menu_run)
		If $app9_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	If $app10 <> "" Then
		$menu_app10 = GUICtrlCreateMenuItem($app10, $menu_run)
		If $app10_a = "0" Then GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	$menu_help = GUICtrlCreateMenu("Help")
		GUICtrlCreateMenuItem("Donate me!", $menu_help)
		GUICtrlSetOnEvent(-1, "menu_donate")
		GUICtrlSetState(-1, $GUI_DEFBUTTON)
		GUICtrlCreateMenuItem("", $menu_help)
		$menu_download = GUICtrlCreateMenu("Download", $menu_help)
			$menu_tv_app = GUICtrlCreateMenuItem("Download TV app", $menu_download)
			$menu_pc_app = GUICtrlCreateMenuItem("Look for new version", $menu_download)
		GUICtrlCreateMenuItem("", $menu_help)
		$menu_www = GUICtrlCreateMenuItem("SamyGO.tv", $menu_help)
		$menu_forum = GUICtrlCreateMenuItem("Forum", $menu_help)
		GUICtrlCreateMenuItem("", $menu_help)
		$menu_about = GUICtrlCreateMenuItem("About", $menu_help)
		If $tv_model <> "" Then
			If $tv_model = "B650" Then
				GUICtrlSetState($menu_b650, $GUI_CHECKED)
				If $tv_remote = "938" Then
					GUICtrlSetState($menu_b650_938, $GUI_CHECKED)
				ElseIf $tv_remote = "861" Then
					GUICtrlSetState($menu_b650_861, $GUI_CHECKED)
				EndIf
			ElseIf $tv_model = "B6000" Then
				GUICtrlSetState($menu_b6000, $GUI_CHECKED)
			ElseIf $tv_model = "A956" Then
				GUICtrlSetState($menu_a956, $GUI_CHECKED)
			ElseIf $tv_model = "SOAP" Then
				GUICtrlSetState($menu_soap, $GUI_CHECKED)
			EndIf
		EndIf
EndIf

If $hide_status <> "1" Then
	If _WinAPI_GetVersion() > '6.0' Then
		If _WinAPI_IsInternetConnected() Then
			$connected = "  |  Internet: Connected"
		Else
			$connected = "  |  Internet: Not Connected!"
		EndIf
	Else
		$connected = ""
	EndIf
	$tv_mode = "TV: " & $tv_model
	If $tv_model = "SOAP" Then $tv_mode = "SOAP/UPnP mode"
	$status = _GUICtrlStatusBar_Create($GUI)
	_GUICtrlStatusBar_SetText($status, " " & $tv_mode & "  |  IP: " & $tv_ip & $connected)
EndIf

If $tv_model <> "" Then
	If $tv_model = "B650" Then
		If $tv_remote = "938" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)
$btn_tv		= GUICtrlCreateButton("TV",			 45,  55,  60,  25)

$btn_1		= GUICtrlCreateButton("1",			 45,  85,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  85,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  85,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_2e		= GUICtrlCreateButton("",			160,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_3e		= GUICtrlCreateButton("",			225,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_4		= GUICtrlCreateButton("4",			 45, 115,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110, 115,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175, 115,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_5e		= GUICtrlCreateButton("",			160, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_6e		= GUICtrlCreateButton("",			225, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_7		= GUICtrlCreateButton("7",			 45, 145,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 145,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 145,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_8e		= GUICtrlCreateButton("",			160, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_9e		= GUICtrlCreateButton("",			225, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_favch	= GUICtrlCreateButton("FAV.CH",		 45, 175,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 175,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 175,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 175,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 205,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 210,  40,  20)
$btn_chup	= GUICtrlCreateButton("P +",		175, 205,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 235,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 240,  40,  20)
$btn_chdn	= GUICtrlCreateButton("P -",		175, 235,  60,  30)

$btn_info	= GUICtrlCreateButton("INFO",		 45, 270,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 270,  60,  30)
$btn_guide	= GUICtrlCreateButton("GUIDE",		175, 270,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 295,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 295,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 338,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 310,  60,  20)

$btn_left	= GUICtrlCreateButton("",			 90, 330,  20,  60)
$btn_right	= GUICtrlCreateButton("",			170, 330,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 390,  60,  20)

$btn_internet = GUICtrlCreateButton("INTERNET",	 45, 395,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 395,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 430,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 430,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 430,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 430,  44,  20)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 455,  60,  20)
$btn_media	= GUICtrlCreateButton("MEDIA.P",	110, 455,  60,  20)
$btn_content= GUICtrlCreateButton("CONTENT",	175, 455,  60,  20)

$btn_chlist	= GUICtrlCreateButton("CH LIST",	 45, 480,  60,  20)
$btn_ad		= GUICtrlCreateButton("AD",			110, 480,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 480,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 505,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 505,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 505,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 530,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 530,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 530,  60,  20)

GUICtrlCreateLabel("BN59-00938A",	51, 560)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 6)

		ElseIf $tv_remote = "861" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)
$btn_tv		= GUICtrlCreateButton("TV",			 45,  55,  60,  25)

$btn_1		= GUICtrlCreateButton("1",			 45,  85,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  85,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  85,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_2e		= GUICtrlCreateButton("",			160,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_3e		= GUICtrlCreateButton("",			225,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_4		= GUICtrlCreateButton("4",			 45, 115,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110, 115,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175, 115,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_5e		= GUICtrlCreateButton("",			160, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_6e		= GUICtrlCreateButton("",			225, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_7		= GUICtrlCreateButton("7",			 45, 145,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 145,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 145,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_8e		= GUICtrlCreateButton("",			160, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_9e		= GUICtrlCreateButton("",			225, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_space	= GUICtrlCreateButton("-/--",		 45, 175,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 175,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 175,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 175,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 205,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 210,  40,  20)
$btn_chup	= GUICtrlCreateButton("P +",		175, 205,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 235,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 240,  40,  20)
$btn_chdn	= GUICtrlCreateButton("P -",		175, 235,  60,  30)

$btn_chlist	= GUICtrlCreateButton("CH LIST",	 45, 270,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 270,  60,  30)
$btn_favch	= GUICtrlCreateButton("FAV.CH",		175, 270,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 295,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 295,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 338,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 310,  60,  20)
$btn_left	= GUICtrlCreateButton("",			 90, 330,  20,  60)
$btn_right	= GUICtrlCreateButton("",			170, 330,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 390,  60,  20)

$btn_internet = GUICtrlCreateButton("INTERNET",	 45, 395,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 395,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 430,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 430,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 430,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 430,  44,  20)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 455,  60,  20)
$btn_media	= GUICtrlCreateButton("MEDIA.P",	110, 455,  60,  20)
$btn_content= GUICtrlCreateButton("CONTENT",	175, 455,  60,  20)

$btn_info	= GUICtrlCreateButton("INFO",		 45, 480,  60,  20)
$btn_guide	= GUICtrlCreateButton("GUIDE",		110, 480,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 480,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 505,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 505,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 505,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 530,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 530,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 530,  60,  20)

GUICtrlCreateLabel("BN59-00861A",	51, 560)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetColor(-1,0xFFFFFF)
GUICtrlSetFont(-1, 6)

		EndIf

GUICtrlCreateGroup("Aspect ratio",		285,  10, 150,  71)
	$btn_asp43	= GUICtrlCreateButton("4:3",			290,  25,  70,  25)
	$btn_asp169	= GUICtrlCreateButton("16:9",			360,  25,  70,  25)
	$btn_psize	= GUICtrlCreateButton("Picture size",	290,  50,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Picture mode",		285,  80, 150, 71)
	$btn_pmode		= GUICtrlCreateButton("Switch mode",	290,  95,  70,  25)
	$btn_dynamic	= GUICtrlCreateButton("Dynamic",		360,  95,  70,  25)
	$btn_standard	= GUICtrlCreateButton("Standard",		290, 120,  70,  25)
	$btn_movie		= GUICtrlCreateButton("Movie",			360, 120,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Direct source",		285, 150, 150, 146)
	$btn_scart1	= GUICtrlCreateButton("Scart 1",	290, 165,  70,  25)
	$btn_hdmi1	= GUICtrlCreateButton("HDMI 1",		360, 165,  70,  25)
	$btn_scart2	= GUICtrlCreateButton("Scart 2",	290, 190,  70,  25)
	$btn_hdmi2	= GUICtrlCreateButton("HDMI 2",		360, 190,  70,  25)
	$btn_module	= GUICtrlCreateButton("Module",		290, 215,  70,  25)
	$btn_hdmi3	= GUICtrlCreateButton("HDMI3/DVI",	360, 215,  70,  25)
	$btn_av		= GUICtrlCreateButton("AV", 		290, 240,  70,  25)
	$btn_hdmi4	= GUICtrlCreateButton("HDMI 4",		360, 240,  70,  25)
	$btn_vga	= GUICtrlCreateButton("VGA (PC)",	290, 265,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("PIP",				285, 295, 150,  71)
	$btn_pip	= GUICtrlCreateButton("PIP on/off",		290, 310,  70,  25)
	$btn_pip1	= GUICtrlCreateButton("Full mode 1",	360, 310,  70,  25)
	$btn_pip2	= GUICtrlCreateButton("Full mode 2",	290, 335,  70,  25)
	$btn_pip_x	= GUICtrlCreateButton("Exit PIP",		360, 335,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Extra keys",		285, 365, 150,  71)
	$btn_energy	= GUICtrlCreateButton("Energy save",	290, 380,  70,  25)
	$btn_sleep	= GUICtrlCreateButton("Sleep",			360, 380,  70,  25)
	$btn_srs	= GUICtrlCreateButton("SRS on/off",		290, 405,  70,  25)
	$btn_smode	= GUICtrlCreateButton("Sound mode",		360, 405,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Keys sequences",	285, 435, 150,  71)
	$btn_dvb	= GUICtrlCreateButton("DVB signal",		290, 450,  70,  25)
	$btn_hnc	= GUICtrlCreateButton("Home Net",		360, 450,  70,  25)
	$btn_spk	= GUICtrlCreateButton("Sel.Speakers",	290, 475,  70,  25)
	If $user_btn_seq = "1" Then
		$btn_user_seq = GUICtrlCreateButton($user_btn_name,	360, 475,  70,  25)
		GUICtrlSetOnEvent($btn_user_seq,	"key_user_seq")
	EndIf
GUICtrlCreateGroup("",-99,-99,1,1)

If $user_btn <> "0" Then
	If $user_btn >= "1" Then
		$btn_user1 = GUICtrlCreateButton($user_btn_name1,	290, 520,  70,  25)
		GUICtrlSetOnEvent($btn_user1,	"key_user1")
		If $user_btn = "2" Then
			$btn_user2 = GUICtrlCreateButton($user_btn_name2,	360, 520,  70,  25)
			GUICtrlSetOnEvent($btn_user2,	"key_user2")
		EndIf
	EndIf
	GUICtrlCreateGroup($user_box_name,	285, 505, 150, 46)
	GUICtrlCreateGroup("",-99,-99,1,1)
EndIf

$progress = GUICtrlCreateProgress(290, 575, 140, 15)
GUICtrlSetLimit(-1, 100, 0)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetState($btn_pip_x, $GUI_DISABLE)

	ElseIf $tv_model = "B6000" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)
$btn_tv		= GUICtrlCreateButton("TV",			175,  25,  60,  25)

$btn_1		= GUICtrlCreateButton("1",			 45,  55,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  55,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  55,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  55,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_2e		= GUICtrlCreateButton("",			160,  55,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_3e		= GUICtrlCreateButton("",			225,  55,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_4		= GUICtrlCreateButton("4",			 45,  85,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110,  85,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175,  85,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_5e		= GUICtrlCreateButton("",			160,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_6e		= GUICtrlCreateButton("",			225,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_7		= GUICtrlCreateButton("7",			 45, 115,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 115,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 115,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_8e		= GUICtrlCreateButton("",			160, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_9e		= GUICtrlCreateButton("",			225, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_space	= GUICtrlCreateButton("-/--",		 45, 145,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 145,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 145,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_chlist	= GUICtrlCreateButton("CH LIST",	 45, 175,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 175,  60,  30)
$btn_favch	= GUICtrlCreateButton("FAV.CH",		175, 175,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 200,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 200,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 243,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 215,  60,  20)
$btn_left	= GUICtrlCreateButton("",			 90, 235,  20,  60)
$btn_right	= GUICtrlCreateButton("",			170, 235,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 295,  60,  20)

$btn_info	= GUICtrlCreateButton("INFO",		 45, 300,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 300,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 335,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 335,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 335,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 335,  44,  20)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 360,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 365,  40,  20)
$btn_chup	= GUICtrlCreateButton("CH +",		175, 360,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 390,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 395,  40,  20)
$btn_chdn	= GUICtrlCreateButton("CH -",		175, 390,  60,  30)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 425,  60,  20)
$btn_media	= GUICtrlCreateButton("MEDIA.P",	110, 425,  60,  20)
$btn_psize	= GUICtrlCreateButton("P.SIZE",		175, 425,  60,  20)

$btn_dual	= GUICtrlCreateButton("DUAL",		 45, 450,  60,  20)
$btn_guide	= GUICtrlCreateButton("GUIDE",		110, 450,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 450,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 475,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 475,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 475,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 500,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 500,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 500,  60,  20)

	ElseIf $tv_model = "A956" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)

$btn_source_tv	= GUICtrlCreateButton("TV",		110,  30,  29,  17)
$btn_source_vcr	= GUICtrlCreateButton("VCR",	142,  30,  29,  17)
$btn_source_dvd	= GUICtrlCreateButton("DVD",	174,  30,  29,  17)
$btn_source_stb	= GUICtrlCreateButton("STB",	206,  30,  29,  17)

$btn_1		= GUICtrlCreateButton("1",			 45,  55,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  55,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  55,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  55,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_2e		= GUICtrlCreateButton("",			160,  55,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_3e		= GUICtrlCreateButton("",			225,  55,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_4		= GUICtrlCreateButton("4",			 45,  85,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110,  85,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175,  85,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_5e		= GUICtrlCreateButton("",			160,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_6e		= GUICtrlCreateButton("",			225,  85,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_7		= GUICtrlCreateButton("7",			 45, 115,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 115,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 115,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_8e		= GUICtrlCreateButton("",			160, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)
$btn_9e		= GUICtrlCreateButton("",			225, 115,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_space	= GUICtrlCreateButton("-/--",		 45, 145,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 145,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 145,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 145,  10,  15)
	GUICtrlSetState(-1, $GUI_HIDE)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 175,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 180,  40,  20)
$btn_chup	= GUICtrlCreateButton("P +",		175, 175,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 205,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 210,  40,  20)
$btn_chdn	= GUICtrlCreateButton("P -",		175, 205,  60,  30)

$btn_guide	= GUICtrlCreateButton("GUIDE",		 45, 240,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 240,  60,  30)
$btn_wlink	= GUICtrlCreateButton("W.LINK",		175, 240,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 265,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 265,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 308,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 280,  60,  20)
$btn_left	= GUICtrlCreateButton("",			 90, 300,  20,  60)
$btn_right	= GUICtrlCreateButton("",			170, 300,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 360,  60,  20)

$btn_info 	= GUICtrlCreateButton("INFO",		 45, 365,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 365,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 400,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 400,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 400,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 400,  44,  20)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 425,  60,  20)
$btn_infol	= GUICtrlCreateButton("INFO.L",		110, 425,  60,  20)
$btn_dma	= GUICtrlCreateButton("DMA",		175, 425,  60,  20)

$btn_emode	= GUICtrlCreateButton("E.MODE",		 45, 450,  60,  20)
$btn_content= GUICtrlCreateButton("CONTENT",	110, 450,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 450,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 475,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 475,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 475,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 500,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 500,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 500,  60,  20)

GUICtrlCreateLabel("BN59-00702A",	51, 560)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 6)

GUICtrlCreateGroup("Aspect ratio",		285,  10, 150,  71)
	$btn_asp43	= GUICtrlCreateButton("4:3",			290,  25,  70,  25)
	$btn_asp169	= GUICtrlCreateButton("16:9",			360,  25,  70,  25)
	$btn_psize	= GUICtrlCreateButton("Picture size",	290,  50,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Picture mode",		285,  80, 150, 71)
	$btn_pmode		= GUICtrlCreateButton("Switch mode",	290,  95,  70,  25)
	$btn_dynamic	= GUICtrlCreateButton("Dynamic",		360,  95,  70,  25)
	$btn_standard	= GUICtrlCreateButton("Standard",		290, 120,  70,  25)
	$btn_movie		= GUICtrlCreateButton("Movie",			360, 120,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Direct source",		285, 150, 150, 146)
	$btn_scart1	= GUICtrlCreateButton("Scart 1",	290, 165,  70,  25)
	$btn_hdmi1	= GUICtrlCreateButton("HDMI 1",		360, 165,  70,  25)
	$btn_scart2	= GUICtrlCreateButton("Scart 2",	290, 190,  70,  25)
	$btn_hdmi2	= GUICtrlCreateButton("HDMI 2",		360, 190,  70,  25)
	$btn_module	= GUICtrlCreateButton("Module",		290, 215,  70,  25)
	$btn_hdmi3	= GUICtrlCreateButton("HDMI3/DVI",	360, 215,  70,  25)
	$btn_av		= GUICtrlCreateButton("AV", 		290, 240,  70,  25)
	$btn_hdmi4	= GUICtrlCreateButton("HDMI 4",		360, 240,  70,  25)
	$btn_vga	= GUICtrlCreateButton("VGA (PC)",	290, 265,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

GUICtrlCreateGroup("Extra keys",		285, 295, 150,  71)
	$btn_energy	= GUICtrlCreateButton("Energy save",	290, 310,  70,  25)
	$btn_sleep	= GUICtrlCreateButton("Sleep",			360, 310,  70,  25)
	$btn_srs	= GUICtrlCreateButton("SRS on/off",		290, 335,  70,  25)
	$btn_smode	= GUICtrlCreateButton("Sound mode",		360, 335,  70,  25)
GUICtrlCreateGroup("",-99,-99,1,1)

If $user_btn_seq = "1" Then
	$width_group = "71"
	$top_btn = "450"
	$top_group = "435"
Else
	$width_group = "46"
	$top_btn = "425"
	$top_group = "410"
EndIf

GUICtrlCreateGroup("Keys sequences",	285, 365, 150,  $width_group)
	$btn_dvb	= GUICtrlCreateButton("DVB signal",		290, 380,  70,  25)
	$btn_spk	= GUICtrlCreateButton("Sel.Speakers",	360, 380,  70,  25)
	If $user_btn_seq = "1" Then
		$btn_user_seq = GUICtrlCreateButton($user_btn_name,	290, 405,  70,  25)
		GUICtrlSetOnEvent($btn_user_seq,	"key_user_seq")
	EndIf
GUICtrlCreateGroup("",-99,-99,1,1)

If $user_btn <> "0" Then
	If $user_btn >= "1" Then
		$btn_user1 = GUICtrlCreateButton($user_btn_name1,	290, $top_btn,  70,  25)
		GUICtrlSetOnEvent($btn_user1,	"key_user1")
		If $user_btn = "2" Then
			$btn_user2 = GUICtrlCreateButton($user_btn_name2,	360, $top_btn,  70,  25)
			GUICtrlSetOnEvent($btn_user2,	"key_user2")
		EndIf
	EndIf
	GUICtrlCreateGroup($user_box_name,	285, $top_group, 150, 46)
	GUICtrlCreateGroup("",-99,-99,1,1)
EndIf

$progress = GUICtrlCreateProgress(290, 575, 140, 15)
GUICtrlSetLimit(-1, 100, 0)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetState($btn_pip_x, $GUI_DISABLE)

	ElseIf $tv_model = "SOAP" Then

GUICtrlCreateLabel("Volume:",		  5,  24,  60,  20, $SS_RIGHT)
$slider_soap_volume		= GUICtrlCreateSlider(				 70,  20, 140,  25)
	GUICtrlSetState(-1, $GUI_DISABLE)
$input_soap_volume		= GUICtrlCreateInput("",			300,  20,  45,  25, $SS_CENTER)
	GUICtrlSetLimit(-1, 100, 0)
GUICtrlCreateUpDown($input_soap_volume)
	GUICtrlSetLimit(-1, 100, 0)
$btn_soap_set_volume	= GUICtrlCreateButton("Set",		350,  20,  40,  25)
$btn_soap_volume_mute	= GUICtrlCreateButton("Mute",		210,  20,  50,  25)
$lbl_soap_volume_mute	= GUICtrlCreateLabel("Mute" & @CRLF & "ON", 263,  20, 30, 25, $SS_CENTER)
	GUICtrlSetColor(-1, 0xFF0000)
	GUICtrlSetFont(-1, 4, 400, 0, "MS Sans Serif")
	GUICtrlSetState(-1, $GUI_HIDE)

GUICtrlCreateLabel("Brightness:",	  5,  54,  60,  20, $SS_RIGHT)
$slider_soap_brightness		= GUICtrlCreateSlider(			 70,  50, 140,  25)
	GUICtrlSetState(-1, $GUI_DISABLE)
$input_soap_brightness		= GUICtrlCreateInput("",		300,  50,  45,  25, $SS_CENTER)
	GUICtrlSetLimit(-1, 100, 0)
GUICtrlCreateUpDown($input_soap_brightness)
	GUICtrlSetLimit(-1, 100, 0)
$btn_soap_set_brightness	= GUICtrlCreateButton("Set",	350,  50,  40,  25)

GUICtrlCreateLabel("Contrast:",		  5,  84,  60,  20, $SS_RIGHT)
$slider_soap_contrast		= GUICtrlCreateSlider(			 70,  80, 140,  25)
	GUICtrlSetState(-1, $GUI_DISABLE)
$input_soap_contrast		= GUICtrlCreateInput("",		300,  80,  45,  25, $SS_CENTER)
	GUICtrlSetLimit(-1, 100, 0)
GUICtrlCreateUpDown($input_soap_contrast)
	GUICtrlSetLimit(-1, 100, 0)
$btn_soap_set_contrast		= GUICtrlCreateButton("Set",	350,  80,  40,  25)

GUICtrlCreateLabel("Sharpness:",	  5, 114,  60,  20, $SS_RIGHT)
$slider_soap_sharpness		= GUICtrlCreateSlider(			 70, 110, 140,  25)
	GUICtrlSetState(-1, $GUI_DISABLE)
$input_soap_sharpness		= GUICtrlCreateInput("",		300, 110,  45,  25, $SS_CENTER)
	GUICtrlSetLimit(-1, 100, 0)
GUICtrlCreateUpDown($input_soap_sharpness)
	GUICtrlSetLimit(-1, 100, 0)
$btn_soap_set_sharpness		= GUICtrlCreateButton("Set",	350, 110,  40,  25)

GUICtrlCreateLabel("ColorTemp.:",	  5, 144,  60,  20, $SS_RIGHT)
$dd_soap_colortemp			= GUICtrlCreateCombo("",		 70, 140, 140,  25, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "Cool|Normal|Warm1|Warm2|Warm3", "Cool")
$input_soap_colortemp		= GUICtrlCreateInput("",		300, 140,  45,  25, $SS_CENTER)
	GUICtrlSetState(-1, $GUI_DISABLE)
$btn_soap_set_colortemp		= GUICtrlCreateButton("Set",	350, 140,  40,  25)

$btn_soap_setall		= GUICtrlCreateButton("Set ALL",	300, 170,  90,  25)


$btn_soap_refresh		= GUICtrlCreateButton("Refresh",	130, 220, 140,  20)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
	EndIf
EndIf

If $fast_btn = "1" Then
	$btn_width=60
	GUICtrlSetState($btn_1e, $GUI_SHOW)
	GUICtrlSetState($btn_2e, $GUI_SHOW)
	GUICtrlSetState($btn_3e, $GUI_SHOW)
	GUICtrlSetState($btn_4e, $GUI_SHOW)
	GUICtrlSetState($btn_5e, $GUI_SHOW)
	GUICtrlSetState($btn_6e, $GUI_SHOW)
	GUICtrlSetState($btn_7e, $GUI_SHOW)
	GUICtrlSetState($btn_8e, $GUI_SHOW)
	GUICtrlSetState($btn_9e, $GUI_SHOW)
	GUICtrlSetState($btn_0e, $GUI_SHOW)
EndIf

If $source_scart1 <> "" Then GUICtrlSetData($btn_scart1, $source_scart1)
If $source_scart2 <> "" Then GUICtrlSetData($btn_scart2, $source_scart2)
If $source_module <> "" Then GUICtrlSetData($btn_module, $source_module)
If $source_av <> "" Then GUICtrlSetData($btn_av, $source_av)
If $source_vga <> "" Then GUICtrlSetData($btn_vga, $source_vga)
If $source_hdmi1 <> "" Then GUICtrlSetData($btn_hdmi1, $source_hdmi1)
If $source_hdmi2 <> "" Then GUICtrlSetData($btn_hdmi2, $source_hdmi2)
If $source_hdmi3 <> "" Then GUICtrlSetData($btn_hdmi3, $source_hdmi3)
If $source_hdmi4 <> "" Then GUICtrlSetData($btn_hdmi4, $source_hdmi4)

If $symbols = "1" And $tv_model <> "SOAP" Then
	GUICtrlSetData($btn_up, ChrW(9650))
	GUICtrlSetData($btn_down, ChrW(9660))
	GUICtrlSetData($btn_left, ChrW(9664))
	GUICtrlSetFont($btn_left, 18)
	GUICtrlSetData($btn_right, ChrW(9654))
	GUICtrlSetFont($btn_right, 18)
	GUICtrlSetData($btn_fb, ChrW(9665) & ChrW(9665))
	GUICtrlSetFont($btn_fb, 12)
	GUICtrlSetData($btn_pause, ChrW(2615) & " " & ChrW(2621))
	GUICtrlSetFont($btn_pause, 10)
	GUICtrlSetData($btn_ff, ChrW(9655) & ChrW(9655))
	GUICtrlSetFont($btn_ff, 12)
	GUICtrlSetData($btn_rec, ChrW(9673))
	GUICtrlSetFont($btn_rec, 18)
	GUICtrlSetData($btn_play, ChrW(9655))
	GUICtrlSetFont($btn_play, 17)
	GUICtrlSetData($btn_stop, ChrW(9633))
	GUICtrlSetFont($btn_stop, 13)
	GUICtrlSetData($btn_volup, ChrW(10010))
	GUICtrlSetFont($btn_volup, 12)
	GUICtrlSetData($btn_voldn, ChrW(9644))
	GUICtrlSetFont($btn_voldn, 11)
	GUICtrlSetData($btn_chup, ChrW(9650))
	GUICtrlSetFont($btn_chup, 12)
	GUICtrlSetData($btn_chdn, ChrW(9660))
	GUICtrlSetFont($btn_chdn, 12)
	If $tv_model <> "" Then
		If $tv_model = "B650" Then
			$top_lbl_vp = 205
		ElseIf $tv_model = "A956" Then
			$top_lbl_vp = 175
		ElseIf $tv_model = "B6000" Then
			$top_lbl_vp = 360
		EndIf
		$lbl_v = GUICtrlCreateLabel("V", 109, $top_lbl_vp)
		$lbl_p = GUICtrlCreateLabel("P", 164, $top_lbl_vp)
		GUICtrlSetBkColor($lbl_v, $GUI_BKCOLOR_TRANSPARENT)
		GUICtrlSetColor($lbl_v, 0xFFFFFF)
		GUICtrlSetFont($lbl_v, 8, 1200)
		GUICtrlSetBkColor($lbl_p, $GUI_BKCOLOR_TRANSPARENT)
		GUICtrlSetColor($lbl_p, 0xFFFFFF)
		GUICtrlSetFont($lbl_p, 8, 1200)
	EndIf
EndIf

GUICtrlCreateLabel("v" & $version, 344, 618, 100, 20, $SS_RIGHT)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetColor(-1, 0x909090)

GUISetState()		 ; show main GUI
Opt("GUIOnEventMode", 1)

	GUICtrlSetTip($btn_power, "Turn off TV and exit application")
	GUICtrlSetTip($btn_dvb, "Open TV menu and go to dialog with DVB-T signal check")
	GUICtrlSetTip($btn_hnc, "Open TV menu, go to Home Network Centre and allow/block SOAP services")
	GUICtrlSetTip($btn_spk, "Open TV menu and switch between externel/internal speakers")
; MAIN WINDOW ----------------------------------------- end

; CONTEXT MENU --------------------------------------------
$Context = GUICtrlCreateContextMenu()
$cnt_config = GUICtrlCreateMenuItem("Configuration", $Context)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
If $tv_model = "B650" Or $tv_model = "A956" Then
	If $extra_buttons = "1" Then
		$cnt_buttons = GUICtrlCreateMenuItem("Hide extra buttons panel", $Context)
	ElseIf $extra_buttons = "0" Then
		$cnt_buttons = GUICtrlCreateMenuItem("Show extra buttons panel", $Context)
	EndIf
EndIf
GUICtrlCreateMenuItem("", $Context)
$Context_sub = GUICtrlCreateMenu("Download", $Context)
$cnt_tv_app = GUICtrlCreateMenuItem("Download TV app", $Context_sub)
	If $tv_app = "" Then GUICtrlSetState(-1, $GUI_DISABLE)
$cnt_pc_app = GUICtrlCreateMenuItem("Check for new version", $Context_sub)
	If $pc_app = "" Then GUICtrlSetState(-1, $GUI_DISABLE)
$cnt_www = GUICtrlCreateMenuItem("SamyGO.tv", $Context)
GUICtrlCreateMenuItem("", $Context)
$cnt_about = GUICtrlCreateMenuItem("About", $Context)
; CONTEXT MENU ---------------------------------------- end

; TRAY MENU  ----------------------------------------------
$tray_restore = TrayCreateItem("Restore app")
TrayCreateItem("")
$tray_exit = TrayCreateItem("Exit")
TrayItemSetOnEvent($tray_restore,	"tray_restore")
TrayItemSetOnEvent($tray_exit,	"end")
; TRAY MENU  ------------------------------------------ end

; CONFIGURATION WINDOW ------------------------------------
$GUI_config = GUICreate("Configuration", 450, 400)
GUISetStyle(BitOR($WS_SYSMENU,$WS_CAPTION,$WS_BORDER))
	$tv_ip_input = _GUICtrlIpAddress_Create($GUI_config, 72, 62, 130, 20)
	_GUICtrlIpAddress_Set($tv_ip_input, $tv_ip)
$GUI_config = GUISetState(@SW_HIDE)
$GUI_config = GUISetOnEvent($GUI_EVENT_CLOSE,	"config_box")
	$Tab = GUICtrlCreateTab(4, 5, 444, 360)
	GUICtrlSetOnEvent(-1, "_Tab_Switch")
	GUICtrlCreateTabItem("Main")
		GUICtrlCreateLabel("Set IP address of your Samsung TV:", 15, 40, 400)
		GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
		GUICtrlCreateLabel("TV IP:", 35, 65)
		GUICtrlCreateLabel("You local network PC IP: " & @IPAddress1, 35, 90)
		GUICtrlSetColor(-1,0x808080)
		GUICtrlCreateLabel("Choose your TV and remote model:", 15, 140, 400)
		GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
		$tv_model_b650 = GUICtrlCreateRadio("B650", 20, 160)
		$tv_model_b6000 = GUICtrlCreateRadio("B6000 - LED", 20, 185)
		$tv_model_a956 = GUICtrlCreateRadio("A956", 20, 210)
		$tv_model_soap = GUICtrlCreateRadio("universal (SOAP mode)  *", 20, 235)
		If $tv_model = "B650" Then
			GUICtrlSetState($tv_model_b650, $GUI_CHECKED)
		ElseIf $tv_model = "B6000" Then
			GUICtrlSetState($tv_model_b6000, $GUI_CHECKED)
		ElseIf $tv_model = "A956" Then
			GUICtrlSetState($tv_model_a956, $GUI_CHECKED)
		ElseIf $tv_model = "SOAP" Then
			GUICtrlSetState($tv_model_soap, $GUI_CHECKED)
		EndIf
		$tv_remote_list = GUICtrlCreateCombo("", 125, 161, 92, 20, $CBS_DROPDOWNLIST)
		If $tv_remote = "938" Then
			GUICtrlSetData($tv_remote_list, "BN59-00938A|BN59-00861A", "BN59-00938A")
		ElseIf $tv_remote = "861" Then
			GUICtrlSetData($tv_remote_list, "BN59-00938A|BN59-00861A", "BN59-00861A")
		EndIf
		GUICtrlCreateLabel("*  - SOAP mode work for TV from high models series: B, C, D.", 15, 340)
		GUICtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("Sources")
		GUICtrlCreateLabel("Set names for devices connected with your TV as direct sources buttons", 15, 40)
		GUICtrlCreateLabel("Scart 1:", 5, 65, 60, 17, $SS_RIGHT)
		$source_scart1_input = GUICtrlCreateInput($source_scart1, 70, 62, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("HDMI 1:", 205, 65, 60, 17, $SS_RIGHT)
		$source_hdmi1_input = GUICtrlCreateInput($source_hdmi1, 270, 62, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("Scart 2:", 5, 90, 60, 17, $SS_RIGHT)
		$source_scart2_input = GUICtrlCreateInput($source_scart2, 70, 87, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("HDMI 2:", 205, 90, 60, 17, $SS_RIGHT)
		$source_hdmi2_input = GUICtrlCreateInput($source_hdmi2, 270, 87, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("Module:", 5, 115, 60, 17, $SS_RIGHT)
		$source_module_input = GUICtrlCreateInput($source_module, 70, 112, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("HDMI 3 / DVI:", 195, 115, 70, 17, $SS_RIGHT)
		$source_hdmi3_input = GUICtrlCreateInput($source_hdmi3, 270, 112, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("AV:", 5, 140, 60, 17, $SS_RIGHT)
		$source_av_input = GUICtrlCreateInput($source_av, 70, 137, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("HDMI 4:", 205, 140, 60, 17, $SS_RIGHT)
		$source_hdmi4_input = GUICtrlCreateInput($source_hdmi4, 270, 137, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("VGA (PC):", 5, 165, 60, 17, $SS_RIGHT)
		$source_vga_input = GUICtrlCreateInput($source_vga, 70, 162, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("Leave input dialog empty for default source name.", 15, 340)
		GUICtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("User buttons")
		GUICtrlCreateLabel("Create you own remote buttons", 15, 40, 400)
		GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
		GUICtrlCreateGroup(" ", 10, 60, 160, 70)
			GUICtrlCreateLabel("Label:", 10, 80, 50, 17, $SS_RIGHT)
			$user_btn_name1_input = GUICtrlCreateInput($user_btn_name1, 65, 77, 100, 20)
			GUICtrlSetLimit(-1, 15)
			GUICtrlCreateLabel("Keycode:", 10, 105, 50, 17, $SS_RIGHT)
			$user_btn_keycode1_input = GUICtrlCreateInput($user_btn_keycode1, 65, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
		GUICtrlCreateGroup("",-99,-99,1,1)
		$user_button_active1 = GUICtrlCreateCheckbox("Button 1", 20, 55)
		GUICtrlCreateGroup(" ", 175, 60, 160, 70)
			GUICtrlCreateLabel("Label:", 175, 80, 50, 17, $SS_RIGHT)
			$user_btn_name2_input = GUICtrlCreateInput($user_btn_name2, 230, 77, 100, 20)
			GUICtrlSetLimit(-1, 15)
			GUICtrlCreateLabel("Keycode:", 175, 105, 50, 17, $SS_RIGHT)
			$user_btn_keycode2_input = GUICtrlCreateInput($user_btn_keycode2, 230, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
		GUICtrlCreateGroup("",-99,-99,1,1)
		$user_button_active2 = GUICtrlCreateCheckbox("Button 2", 185, 55)
		If $user_btn = "1" Then
			GUICtrlSetState($user_button_active1, $GUI_CHECKED)
		ElseIf $user_btn = "2" Then
			GUICtrlSetState($user_button_active1, $GUI_CHECKED)
			GUICtrlSetState($user_button_active2, $GUI_CHECKED)
		EndIf
		GUICtrlCreateLabel("Section title:", 15, 140)
		$user_box_name_input = GUICtrlCreateInput($user_box_name, 77, 137, 180, 20)
		GUICtrlSetLimit(-1, 30)
		GUICtrlCreateLabel("Preper own action button from keycodes sequence", 15, 210, 400)
		GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
		GUICtrlCreateGroup(" ", 10, 230, 325, 70)
			$user_btn_seq_active = GUICtrlCreateCheckbox("Button from keys sequence", 20, 225)
			If $user_btn_seq = "1" Then GUICtrlSetState($user_btn_seq_active, $GUI_CHECKED)
			GUICtrlCreateLabel("1.", 10, 250, 20, 17, $SS_RIGHT)
			$user_btn_key1_input = GUICtrlCreateInput($user_btn_key1, 35, 247, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("2.", 74, 250, 20, 17, $SS_RIGHT)
			$user_btn_key2_input = GUICtrlCreateInput($user_btn_key2, 99, 247, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("3.", 138, 250, 20, 17, $SS_RIGHT)
			$user_btn_key3_input = GUICtrlCreateInput($user_btn_key3, 163, 247, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("4.", 202, 250, 20, 17, $SS_RIGHT)
			$user_btn_key4_input = GUICtrlCreateInput($user_btn_key4, 227, 247, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("5.", 266, 250, 20, 17, $SS_RIGHT)
			$user_btn_key5_input = GUICtrlCreateInput($user_btn_key5, 291, 247, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("6.", 10, 275, 20, 17, $SS_RIGHT)
			$user_btn_key6_input = GUICtrlCreateInput($user_btn_key6, 35, 272, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("7.", 74, 275, 20, 17, $SS_RIGHT)
			$user_btn_key7_input = GUICtrlCreateInput($user_btn_key7, 99, 272, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("8.", 138, 275, 20, 17, $SS_RIGHT)
			$user_btn_key8_input = GUICtrlCreateInput($user_btn_key8, 163, 272, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("9.", 202, 275, 20, 17, $SS_RIGHT)
			$user_btn_key9_input = GUICtrlCreateInput($user_btn_key9, 227, 272, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("10.", 266, 275, 20, 17, $SS_RIGHT)
			$user_btn_key0_input = GUICtrlCreateInput($user_btn_key0, 291, 272, 35, 20)
			GUICtrlSetLimit(-1, 4)
		GUICtrlCreateGroup("",-99,-99,1,1)
		GUICtrlCreateLabel("Button name:", 15, 310)
		$user_btn_name_input = GUICtrlCreateInput($user_btn_name, 84, 307, 85, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("TIP: For bigger delay spaces between key press, put dash ( - ) symbol instead keycode.", 15, 340)
		GUICtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("Hotkeys")
		GUICtrlCreateLabel("Active or disable hotkeys groups:", 15, 40)
		$hotkeys_numeric_active = GUICtrlCreateCheckbox("Numeric hotkeys", 20, 60)
		If $hotkeys_numeric = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$hotkeys_arrows_active = GUICtrlCreateCheckbox("Arrows and Enter key", 20, 80)
		If $hotkeys_arrows = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$hotkeys_media_active = GUICtrlCreateCheckbox("Multimedia keyboard hotkeys", 20, 100)
		If $hotkeys_media = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("readme", 61, 340)
		GUICtrlSetOnEvent(-1, "open_readme")
		GUICtrlSetTip(-1, "Open readme.htm file")
		GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
		GUICtrlSetColor(-1, 0x0066CC)
		GUICtrlCreateLabel("All hotkeys need too be use with [Control] key." & @CRLF & "Look into              file for hotkeys list.", 15, 327)
		GUICtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("CL apps")
		GUICtrlCreateGroup(" ",	10, 40, 430, 272)
		$app_cl_active = GUICtrlCreateCheckbox("Show menu with Content Library apps list and allow run them", 20, 35)
		If $app_cl = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("id", 25, 65)
			GUICtrlSetFont(-1, 6, 400, 4, "MS Sans Serif")
			GUICtrlSetColor(-1, 0x696969)
		GUICtrlCreateLabel("app name", 90, 65)
			GUICtrlSetFont(-1, 6, 400, 4, "MS Sans Serif")
			GUICtrlSetColor(-1, 0x696969)
		GUICtrlCreateLabel("exit CL after run", 220, 65)
			GUICtrlSetFont(-1, 6, 400, 4, "MS Sans Serif")
			GUICtrlSetColor(-1, 0x696969)
		GUICtrlCreateLabel("display at list", 325, 65)
			GUICtrlSetFont(-1, 6, 400, 4, "MS Sans Serif")
			GUICtrlSetColor(-1, 0x696969)
		GUICtrlCreateLabel("1.", 15, 85, 20, 17, $SS_RIGHT)
		$app1_input = GUICtrlCreateCombo("", 45, 82, 150, 20)
		GUICtrlSetData(-1, $app1 & "||" & $app_list1 & "| - |" & $app_list2, $app1)
		$app1_x_active = GUICtrlCreateCheckbox(" ", 250, 82)
		If $app1_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app1_a_active = GUICtrlCreateCheckbox(" ", 350, 82)
		If $app1_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("2.", 15, 107, 20, 17, $SS_RIGHT)
		$app2_input = GUICtrlCreateCombo($app2, 45, 104, 150, 20)
		GUICtrlSetData(-1, $app2 & "||" & $app_list1 & "| - |" & $app_list2, $app2)
		$app2_x_active = GUICtrlCreateCheckbox(" ", 250, 104)
		If $app2_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app2_a_active = GUICtrlCreateCheckbox(" ", 350, 104)
		If $app2_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("3.", 15, 129, 20, 17, $SS_RIGHT)
		$app3_input = GUICtrlCreateCombo($app3, 45, 126, 150, 20)
		GUICtrlSetData(-1, $app3 & "||" & $app_list1 & "| - |" & $app_list2, $app3)
		$app3_x_active = GUICtrlCreateCheckbox(" ", 250, 126)
		If $app3_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app3_a_active = GUICtrlCreateCheckbox(" ", 350, 126)
		If $app3_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("4.", 15, 150, 20, 17, $SS_RIGHT)
		$app4_input = GUICtrlCreateCombo($app4, 45, 148, 150, 20)
		GUICtrlSetData(-1, $app4 & "||" & $app_list1 & "| - |" & $app_list2, $app4)
		$app4_x_active = GUICtrlCreateCheckbox(" ", 250, 148)
		If $app4_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app4_a_active = GUICtrlCreateCheckbox(" ", 350, 148)
		If $app4_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("5.", 15, 172, 20, 17, $SS_RIGHT)
		$app5_input = GUICtrlCreateCombo($app5, 45, 170, 150, 20)
		GUICtrlSetData(-1, $app5 & "||" & $app_list1 & "| - |" & $app_list2, $app5)
		$app5_x_active = GUICtrlCreateCheckbox(" ", 250, 170)
		If $app5_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app5_a_active = GUICtrlCreateCheckbox(" ", 350, 170)
		If $app5_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("6.", 15, 194, 20, 17, $SS_RIGHT)
		$app6_input = GUICtrlCreateCombo($app6, 45, 192, 150, 20)
		GUICtrlSetData(-1, $app6 & "||" & $app_list1 & "| - |" & $app_list2, $app6)
		$app6_x_active = GUICtrlCreateCheckbox(" ", 250, 192)
		If $app6_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app6_a_active = GUICtrlCreateCheckbox(" ", 350, 192)
		If $app6_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("7.", 15, 216, 20, 17, $SS_RIGHT)
		$app7_input = GUICtrlCreateCombo($app7, 45, 214, 150, 20)
		GUICtrlSetData(-1, $app7 & "||" & $app_list1 & "| - |" & $app_list2, $app7)
		$app7_x_active = GUICtrlCreateCheckbox(" ", 250, 214)
		If $app7_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app7_a_active = GUICtrlCreateCheckbox(" ", 350, 214)
		If $app7_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("8.", 15, 238, 20, 17, $SS_RIGHT)
		$app8_input = GUICtrlCreateCombo($app8, 45, 236, 150, 20)
		GUICtrlSetData(-1, $app8 & "||" & $app_list1 & "| - |" & $app_list2, $app8)
		$app8_x_active = GUICtrlCreateCheckbox(" ", 250, 236)
		If $app8_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app8_a_active = GUICtrlCreateCheckbox(" ", 350, 236)
		If $app8_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("9.", 15, 260, 20, 17, $SS_RIGHT)
		$app9_input = GUICtrlCreateCombo($app9, 45, 258, 150, 20)
		GUICtrlSetData(-1, $app9 & "||" & $app_list1 & "| - |" & $app_list2, $app9)
		$app9_x_active = GUICtrlCreateCheckbox(" ", 250, 258)
		If $app9_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app9_a_active = GUICtrlCreateCheckbox(" ", 350, 258)
		If $app9_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("10.", 15, 282, 20, 17, $SS_RIGHT)
		$app10_input = GUICtrlCreateCombo($app10, 45, 280, 150, 20)
		GUICtrlSetData(-1, $app10 & "||" & $app_list1 & "| - |" & $app_list2, $app10)
		$app10_x_active = GUICtrlCreateCheckbox(" ", 250, 280)
		If $app10_x = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$app10_a_active = GUICtrlCreateCheckbox(" ", 350, 280)
		If $app10_a = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateGroup("",-99,-99,1,1)
		$app_cl_new_active = GUICtrlCreateCheckbox("I'm use unofficial Content Library menu", 20, 315)
		If $app_cl_new = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlCreateLabel("Leave input dialog empty for needless entry.", 15, 340)
		GUICtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("Keycode test")
		GUICtrlCreateLabel("Use below input box to test keycodes", 15, 40)
		$input_test = GUICtrlCreateInput("",  15,  70, 100, 20, $SS_CENTER)
		GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
		GUICtrlSetLimit(-1, 4)
		GUICtrlCreateUpDown($input_test)
		GUICtrlSetLimit(-1, 1000, 0)
		$btn_test_send = GUICtrlCreateButton("Send keycode", 120, 70, 100, 20)
		GUICtrlCreateLabel("CAUTION!!! Only for advanced users." & @CRLF & "You can brick/freeze you TV device using this!", 0, 307, 450, 40, $SS_CENTER)
		GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
		GUICtrlSetColor(-1, 0xFF0000)
		GUICtrlCreateLabel("Only A and B-series devices.", 0, 340, 450, 40, $SS_CENTER)
		GUICtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("Other")
		$extra_buttons_active = GUICtrlCreateCheckbox("Show extra buttons on app start [only B650 and A956]", 20, 40)
		If $extra_buttons = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$fast_btn_active = GUICtrlCreateCheckbox("Show buttons for fast change channel with numeric keys", 20, 60)
		If $fast_btn = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$info_ch_active = GUICtrlCreateCheckbox("Display channel infos box always when use buttons CH +/-", 20, 80)
		If $info_ch = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$alt_dvb_active = GUICtrlCreateCheckbox("Alternative DVB checking signal sequence [only B650]", 20, 100)
		If $alt_dvb = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$hide_menu_active = GUICtrlCreateCheckbox("Hide top menu on main window", 20, 120)
		If $hide_menu = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$hide_status_active = GUICtrlCreateCheckbox("Hide status bar on main window", 20, 140)
		If $hide_status = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$symbols_active = GUICtrlCreateCheckbox("Use unicodes as labels for volume, CH +/-, arrows and multimedia buttons", 20, 160)
		If $symbols = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
		$optimize_active = GUICtrlCreateCheckbox("Optimize app memory usage [experimental]", 20, 180)
		If $optimize = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlCreateTabItem("")

$btn_save_config = GUICtrlCreateButton("Save", 5, 370, 70, 25)
GUICtrlSetOnEvent($btn_save_config,	"save_config")
GUICtrlSetTip(-1, "Save settings to configuration file")
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
$btn_restart_config = GUICtrlCreateButton("Restart", 80, 370, 70, 25)
GUICtrlSetOnEvent($btn_restart_config,	"restart")
GUICtrlSetTip(-1, "Exit and start app again for accept new settings")
GUICtrlSetState($btn_restart_config, $GUI_DISABLE)
; CONFIGURATION WINDOW -------------------------------- end

If $tv_ip = "0.0.0.0" Then
	MsgBox(48, "Error - configuration file", "   Problem with IP address. Check your app configuration.")
	$GUI_config = GUISetState()
EndIf

If $hotkeys_numeric = "1" Then
	HotKeySet("^{NUMPAD1}",		"key_1")
	HotKeySet("^{NUMPAD2}",		"key_2")
	HotKeySet("^{NUMPAD3}",		"key_3")
	HotKeySet("^{NUMPAD4}",		"key_4")
	HotKeySet("^{NUMPAD5}",		"key_5")
	HotKeySet("^{NUMPAD6}",		"key_6")
	HotKeySet("^{NUMPAD7}",		"key_7")
	HotKeySet("^{NUMPAD8}",		"key_8")
	HotKeySet("^{NUMPAD9}",		"key_9")
	HotKeySet("^{NUMPAD0}",		"key_0")
	HotKeySet("^{NUMPADADD}",	"key_chup")
	HotKeySet("^{NUMPADSUB}",	"key_chdn")
	HotKeySet("^{NUMPADDOT}",	"key_prech")
	HotKeySet("^{NUMPADENTER}",	"key_enter")
EndIf

If $hotkeys_arrows = "1" Then
	HotKeySet("^{UP}",		"key_up")
	HotKeySet("^{DOWN}",	"key_down")
	HotKeySet("^{LEFT}",	"key_left")
	HotKeySet("^{RIGHT}",	"key_right")
	HotKeySet("^{ENTER}",	"key_enter")
EndIf

If $hotkeys_media = "1" Then
	HotKeySet("^{LAUNCH_MEDIA}",	"key_media")
	HotKeySet("^{LAUNCH_MAIL}",		"key_internet")
	HotKeySet("^{VOLUME_UP}",		"key_volup")
	HotKeySet("^{VOLUME_DOWN}",		"key_voldn")
	HotKeySet("^{VOLUME_MUTE}",		"key_mute")
	HotKeySet("^{MEDIA_PLAY_PAUSE}","key_play")
	HotKeySet("^{MEDIA_STOP}",		"key_stop")
	HotKeySet("^{MEDIA_PREV}",		"key_fb")
	HotKeySet("^{MEDIA_NEXT}",		"key_ff")
	HotKeySet("^{BROWSER_FORWARD}",		"key_up")
	HotKeySet("^{BROWSER_BACK}",		"key_down")
	HotKeySet("^{BROWSER_FAVORITES}",	"key_favch")
	HotKeySet("^{BROWSER_HOME}",		"key_menu")
	HotKeySet("^{BROWSER_STOP}",		"key_return")
	HotKeySet("^{BROWSER_SEARCH}",		"key_content")
EndIf

GUICtrlSetOnEvent($btn_power,	"key_power")
GUICtrlSetOnEvent($btn_tv,	"key_tv")
GUICtrlSetOnEvent($btn_1,	"key_1")
GUICtrlSetOnEvent($btn_2,	"key_2")
GUICtrlSetOnEvent($btn_3,	"key_3")
GUICtrlSetOnEvent($btn_1e,	"key_1e")
GUICtrlSetOnEvent($btn_2e,	"key_2e")
GUICtrlSetOnEvent($btn_3e,	"key_3e")
GUICtrlSetOnEvent($btn_4,	"key_4")
GUICtrlSetOnEvent($btn_5,	"key_5")
GUICtrlSetOnEvent($btn_6,	"key_6")
GUICtrlSetOnEvent($btn_4e,	"key_4e")
GUICtrlSetOnEvent($btn_5e,	"key_5e")
GUICtrlSetOnEvent($btn_6e,	"key_6e")
GUICtrlSetOnEvent($btn_7,	"key_7")
GUICtrlSetOnEvent($btn_8,	"key_8")
GUICtrlSetOnEvent($btn_9,	"key_9")
GUICtrlSetOnEvent($btn_7e,	"key_7e")
GUICtrlSetOnEvent($btn_8e,	"key_8e")
GUICtrlSetOnEvent($btn_9e,	"key_9e")
GUICtrlSetOnEvent($btn_0,	"key_0")
GUICtrlSetOnEvent($btn_0e,	"key_0e")
GUICtrlSetOnEvent($btn_chup,	"key_chup")
GUICtrlSetOnEvent($btn_chdn,	"key_chdn")
GUICtrlSetOnEvent($btn_volup,	"key_volup")
GUICtrlSetOnEvent($btn_voldn,	"key_voldn")
GUICtrlSetOnEvent($btn_favch,	"key_favch")
GUICtrlSetOnEvent($btn_prech,	"key_prech")
GUICtrlSetOnEvent($btn_mute,	"key_mute")
GUICtrlSetOnEvent($btn_source,	"key_source")
GUICtrlSetOnEvent($btn_info,	"key_info")
GUICtrlSetOnEvent($btn_menu,	"key_menu")
GUICtrlSetOnEvent($btn_guide,	"key_guide")
GUICtrlSetOnEvent($btn_tools,	"key_tools")
GUICtrlSetOnEvent($btn_return,	"key_return")
GUICtrlSetOnEvent($btn_enter,	"key_enter")
GUICtrlSetOnEvent($btn_up,		"key_up")
GUICtrlSetOnEvent($btn_left,	"key_left")
GUICtrlSetOnEvent($btn_right,	"key_right")
GUICtrlSetOnEvent($btn_down,	"key_down")
GUICtrlSetOnEvent($btn_internet,"key_internet")
GUICtrlSetOnEvent($btn_exit,	"key_exit")
GUICtrlSetOnEvent($btn_red,		"key_red")
GUICtrlSetOnEvent($btn_green,	"key_green")
GUICtrlSetOnEvent($btn_yellow,	"key_yellow")
GUICtrlSetOnEvent($btn_blue,	"key_blue")
GUICtrlSetOnEvent($btn_ttx,		"key_ttx")
GUICtrlSetOnEvent($btn_media,	"key_media")
GUICtrlSetOnEvent($btn_content,	"key_content")
GUICtrlSetOnEvent($btn_chlist,	"key_chlist")
GUICtrlSetOnEvent($btn_ad,		"key_ad")
GUICtrlSetOnEvent($btn_subt,	"key_subt")
GUICtrlSetOnEvent($btn_fb,		"key_fb")
GUICtrlSetOnEvent($btn_pause,	"key_pause")
GUICtrlSetOnEvent($btn_ff,		"key_ff")
GUICtrlSetOnEvent($btn_rec,		"key_rec")
GUICtrlSetOnEvent($btn_play,	"key_play")
GUICtrlSetOnEvent($btn_stop,	"key_stop")
GUICtrlSetOnEvent($btn_srs,		"key_srs")
GUICtrlSetOnEvent($btn_sleep,	"key_sleep")
GUICtrlSetOnEvent($btn_pip,		"key_pip")
GUICtrlSetOnEvent($btn_pip1,	"key_pip1")
GUICtrlSetOnEvent($btn_pip2,	"key_pip2")
GUICtrlSetOnEvent($btn_pip_x,	"key_pip_x")
GUICtrlSetOnEvent($btn_energy,	"key_energy")
GUICtrlSetOnEvent($btn_smode,	"key_smode")
GUICtrlSetOnEvent($btn_pmode,	"key_pmode")
GUICtrlSetOnEvent($btn_dynamic,	"key_dynamic")
GUICtrlSetOnEvent($btn_standard,"key_standard")
GUICtrlSetOnEvent($btn_movie,	"key_movie")
GUICtrlSetOnEvent($btn_asp43,	"key_asp43")
GUICtrlSetOnEvent($btn_asp169,	"key_asp169")
GUICtrlSetOnEvent($btn_psize,	"key_psize")
GUICtrlSetOnEvent($btn_hdmi1,	"key_hdmi1")
GUICtrlSetOnEvent($btn_hdmi2,	"key_hdmi2")
GUICtrlSetOnEvent($btn_hdmi3,	"key_hdmi3")
GUICtrlSetOnEvent($btn_hdmi4,	"key_hdmi4")
GUICtrlSetOnEvent($btn_scart1,	"key_scart1")
GUICtrlSetOnEvent($btn_scart2,	"key_scart2")
GUICtrlSetOnEvent($btn_module,	"key_module")
GUICtrlSetOnEvent($btn_vga,		"key_vga")
GUICtrlSetOnEvent($btn_av,		"key_av")
GUICtrlSetOnEvent($btn_dvb,		"key_dvb")
GUICtrlSetOnEvent($btn_hnc,		"key_hnc")
GUICtrlSetOnEvent($btn_spk,		"key_spk")

GUICtrlSetOnEvent($btn_source_tv,		"key_source_tv")
GUICtrlSetOnEvent($btn_source_vcr,		"key_source_vcr")
GUICtrlSetOnEvent($btn_source_dvd,		"key_source_dvd")
GUICtrlSetOnEvent($btn_source_stb,		"key_source_stb")
GUICtrlSetOnEvent($btn_emode,	"key_emode")
GUICtrlSetOnEvent($btn_space,	"key_space")
GUICtrlSetOnEvent($btn_wlink,	"key_wlink")
GUICtrlSetOnEvent($btn_infol,	"key_infol")
GUICtrlSetOnEvent($btn_dma,		"key_dma")

GUICtrlSetOnEvent($btn_soap_refresh,		"soap_refresh")
GUICtrlSetOnEvent($btn_soap_volume_mute,	"soap_volume_mute")
GUICtrlSetOnEvent($btn_soap_set_volume,		"soap_set_volume")
GUICtrlSetOnEvent($btn_soap_set_brightness,	"soap_set_brightness")
GUICtrlSetOnEvent($btn_soap_set_contrast,	"soap_set_contrast")
GUICtrlSetOnEvent($btn_soap_set_sharpness,	"soap_set_sharpness")
GUICtrlSetOnEvent($btn_soap_set_colortemp,	"soap_set_colortemp")

GUICtrlSetOnEvent($cnt_config,	"cnt_config")
GUICtrlSetOnEvent($cnt_buttons,	"cnt_buttons")
GUICtrlSetOnEvent($cnt_tv_app,	"cnt_tv_app")
GUICtrlSetOnEvent($cnt_pc_app,	"cnt_pc_app")
GUICtrlSetOnEvent($cnt_www,		"cnt_www")
GUICtrlSetOnEvent($cnt_about,	"cnt_about")

GUICtrlSetOnEvent($menu_config,	"cnt_config")
GUICtrlSetOnEvent($menu_buttons,"cnt_buttons")
GUICtrlSetOnEvent($menu_tv_app,	"cnt_tv_app")
GUICtrlSetOnEvent($menu_pc_app,	"cnt_pc_app")
GUICtrlSetOnEvent($menu_www,	"cnt_www")
GUICtrlSetOnEvent($menu_about,	"cnt_about")
GUICtrlSetOnEvent($menu_forum,	"menu_forum")
GUICtrlSetOnEvent($menu_hotkeys_arrows,	"menu_hotkeys_arrows")
GUICtrlSetOnEvent($menu_hotkeys_numeric,"menu_hotkeys_numeric")
GUICtrlSetOnEvent($menu_hotkeys_media,	"menu_hotkeys_media")
GUICtrlSetOnEvent($menu_b650_938,	"menu_b650_938")
GUICtrlSetOnEvent($menu_b650_861,	"menu_b650_861")
GUICtrlSetOnEvent($menu_b6000,		"menu_b6000")
GUICtrlSetOnEvent($menu_a956,		"menu_a956")
GUICtrlSetOnEvent($menu_soap,		"menu_soap")
GUICtrlSetOnEvent($menu_fast_btn,	"menu_fast_btn")
GUICtrlSetOnEvent($menu_show_status,"menu_show_status")
GUICtrlSetOnEvent($menu_minimize,	"menu_minimize")
GUICtrlSetOnEvent($menu_upnp_devices,	"upnp_devices_list")
GUICtrlSetOnEvent($menu_exit,	"end")
GUICtrlSetOnEvent($menu_app1,	"run_app1")
GUICtrlSetOnEvent($menu_app2,	"run_app2")
GUICtrlSetOnEvent($menu_app3,	"run_app3")
GUICtrlSetOnEvent($menu_app4,	"run_app4")
GUICtrlSetOnEvent($menu_app5,	"run_app5")
GUICtrlSetOnEvent($menu_app6,	"run_app6")
GUICtrlSetOnEvent($menu_app7,	"run_app7")
GUICtrlSetOnEvent($menu_app8,	"run_app8")
GUICtrlSetOnEvent($menu_app9,	"run_app9")
GUICtrlSetOnEvent($menu_app10,	"run_app10")

GUICtrlSetOnEvent($btn_test_send,	"btn_test_send")

If $optimize = "1" Then
	While 1
		_ReduceMemory()
		Sleep(15000)
	WEnd
EndIf

While 1
	Sleep(250)
WEnd

Func cnt_config()
	$GUI_config = GUISetState()
EndFunc

Func cnt_buttons()
	If $extra_buttons = "1" Then
		IniWrite($config, "extra buttons", "visible", "0")
	ElseIf $extra_buttons = "0" Then
		IniWrite($config, "extra buttons", "visible", "1")
	EndIf
	restart()
EndFunc

Func cnt_tv_app()
	ShellExecute($tv_app)
EndFunc

Func cnt_pc_app()
	ShellExecute($pc_app)
EndFunc

Func cnt_www()
	ShellExecute("http://www.samygo.tv")
EndFunc

Func open_readme()
	ShellExecute("readme.htm")
	; at local alias don't work: '#hotkeys'
EndFunc

Func cnt_about()
	MsgBox(64, "About...", "   Remote LAN Control" & @CRLF & "   version: "  & $version & @CRLF & @CRLF & "Created by: moras86" & @CRLF & @CRLF & _
	"Thanks to:" & @CRLF & "	- doodlecz" & @CRLF & "	- sbav1" & @CRLF & "	- juzis28" & @CRLF & "	- tom_van" & @CRLF & @CRLF & "SamyGO  2011-2012")
EndFunc

Func menu_donate()
	MsgBox(68256, "Thanks for donation!", "I am grateful for your support." & @CRLF & "Your donation will help me in future developing of this and other software.")
	ShellExecute('https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=arturmorawski23%40wp%2eeu&lc=PL&item_name=Support%20app%20development&item_number=6L85TNZH6NA38&no_note=0&currency_code=EUR&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHostedGuest')
EndFunc

Func menu_forum()
	ShellExecute($forum)
EndFunc

Func menu_hotkeys_arrows()
	If $hotkeys_arrows = "1" Then
		IniWrite($config, "hotkeys", "arrows", "0")
	ElseIf $hotkeys_arrows = "0" Then
		IniWrite($config, "hotkeys", "arrows", "1")
	EndIf
	restart()
EndFunc

Func menu_hotkeys_numeric()
	If $hotkeys_numeric = "1" Then
		IniWrite($config, "hotkeys", "numeric", "0")
	ElseIf $hotkeys_numeric = "0" Then
		IniWrite($config, "hotkeys", "numeric", "1")
	EndIf
	restart()
EndFunc

Func menu_hotkeys_media()
	If $hotkeys_media = "1" Then
		IniWrite($config, "hotkeys", "media", "0")
	ElseIf $hotkeys_media = "0" Then
		IniWrite($config, "hotkeys", "media", "1")
	EndIf
	restart()
EndFunc

Func menu_b650_938()
	IniWrite($config, "model", "tv", "B650")
	IniWrite($config, "model", "rc", "938")
	restart()
EndFunc

Func menu_b650_861()
	IniWrite($config, "model", "tv", "B650")
	IniWrite($config, "model", "rc", "861")
	restart()
EndFunc

Func menu_b6000()
	IniWrite($config, "model", "tv", "B6000")
	restart()
EndFunc

Func menu_a956()
	IniWrite($config, "model", "tv", "A956")
	restart()
EndFunc

Func menu_soap()
	IniWrite($config, "model", "tv", "SOAP")
	restart()
EndFunc

Func menu_fast_btn()
	If $fast_btn = "1" Then
		IniWrite($config, "other", "fast_btn", "0")
	ElseIf $fast_btn = "0" Then
		IniWrite($config, "other", "fast_btn", "1")
	EndIf
	restart()
EndFunc

Func menu_show_status()
	If $hide_status = "1" Then
		IniWrite($config, "other", "status", "0")
	ElseIf $hide_status = "0" Then
		IniWrite($config, "other", "status", "1")
	EndIf
	restart()
EndFunc

Func menu_minimize()
	WinSetState($GUI, "", @SW_HIDE)
	TraySetIcon("Remote LAN Control.exe", 0)
	Opt("TrayIconHide", 0)
	Opt("TrayOnEventMode",1)
	Opt("TrayMenuMode",1+2)
	If $hotkeys_arrows = "1" Or $hotkeys_media = "1" Or $hotkeys_numeric = "1" Then
		TrayTip("Remote LAN Control v" & $version, "App is now minimalized to tray." & @CRLF & "Right click for options." & @CRLF & @CRLF & "Hotkeys are ready to use!", 10, 1)
	Else
		TrayTip("Remote LAN Control v" & $version, "App is now minimalized to tray." & @CRLF & "Right click for options.", 10, 1)
	EndIf
EndFunc

Func tray_restore()
	WinSetState($GUI, "", @SW_SHOW)
	Opt("TrayIconHide", 1)
EndFunc

Func key_tv()
	SendKeyCode(27)
EndFunc

Func key_1()
	SendKeyCode(4)
EndFunc

Func key_2()
	SendKeyCode(5)
EndFunc

Func key_3()
	SendKeyCode(6)
EndFunc

Func key_4()
	SendKeyCode(8)
EndFunc

Func key_5()
	SendKeyCode(9)
EndFunc

Func key_6()
	SendKeyCode(10)
EndFunc

Func key_7()
	SendKeyCode(12)
EndFunc

Func key_8()
	SendKeyCode(13)
EndFunc

Func key_9()
	SendKeyCode(14)
EndFunc

Func key_0()
	SendKeyCode(17)
EndFunc

Func key_1e()
	key_1()
	Sleep(100)
	key_enter()
EndFunc

Func key_2e()
	key_2()
	Sleep(100)
	key_enter()
EndFunc

Func key_3e()
	key_3()
	Sleep(100)
	key_enter()
EndFunc

Func key_4e()
	key_4()
	Sleep(100)
	key_enter()
EndFunc

Func key_5e()
	key_5()
	Sleep(100)
	key_enter()
EndFunc

Func key_6e()
	key_6()
	Sleep(100)
	key_enter()
EndFunc

Func key_7e()
	key_7()
	Sleep(100)
	key_enter()
EndFunc

Func key_8e()
	key_8()
	Sleep(100)
	key_enter()
EndFunc

Func key_9e()
	key_9()
	Sleep(100)
	key_enter()
EndFunc

Func key_0e()
	key_0()
	Sleep(100)
	key_enter()
EndFunc

Func key_favch()
	SendKeyCode(68)
EndFunc

Func key_prech()
	SendKeyCode(19)
EndFunc

Func key_volup()
	SendKeyCode(7)
EndFunc

Func key_voldn()
	SendKeyCode(11)
EndFunc

Func key_chup()
	SendKeyCode(18)
	If $info_ch=1 Then
		Sleep(250)
		key_info()
	EndIf
EndFunc

Func key_chdn()
	SendKeyCode(16)
	If $info_ch=1 Then
		Sleep(250)
		key_info()
	EndIf
EndFunc

Func key_mute()
	SendKeyCode(15)
EndFunc

Func key_source()
	SendKeyCode(1)
EndFunc

Func key_info()
	SendKeyCode(31)
EndFunc

Func key_tools()
	SendKeyCode(75)
EndFunc

Func key_guide()
	SendKeyCode(79)
EndFunc

Func key_return()
	SendKeyCode(88)
EndFunc

Func key_menu()
	SendKeyCode(26)
EndFunc

Func key_enter()
	SendKeyCode(104)
EndFunc

Func key_up()
	SendKeyCode(96)
EndFunc

Func key_down()
	SendKeyCode(97)
EndFunc

Func key_left()
	SendKeyCode(101)
EndFunc

Func key_right()
	SendKeyCode(98)
EndFunc

Func key_internet()
	SendKeyCode(147)
EndFunc

Func key_exit()
	SendKeyCode(45)
EndFunc

Func key_red()
	SendKeyCode(108)
EndFunc

Func key_green()
	SendKeyCode(20)
EndFunc

Func key_yellow()
	SendKeyCode(21)
EndFunc

Func key_blue()
	SendKeyCode(22)
EndFunc

Func key_ttx()
	SendKeyCode(44)
EndFunc

Func key_media()
	SendKeyCode(140)
EndFunc

Func key_content()
	SendKeyCode(121)
EndFunc

Func key_chlist()
	SendKeyCode(107)
EndFunc

Func key_ad()
	SendKeyCode(39)
EndFunc

Func key_subt()
	SendKeyCode(37)
EndFunc

Func key_fb()
	SendKeyCode(69)
EndFunc

Func key_pause()
	SendKeyCode(74)
EndFunc

Func key_ff()
	SendKeyCode(72)
EndFunc

Func key_rec()
	SendKeyCode(73)
EndFunc

Func key_play()
	SendKeyCode(71)
EndFunc

Func key_stop()
	SendKeyCode(70)
EndFunc

Func key_sleep()
	SendKeyCode(3)
EndFunc

Func key_energy()
	SendKeyCode(119)
EndFunc

Func key_srs()
	SendKeyCode(110)
EndFunc

Func key_psize()
	SendKeyCode(62)
EndFunc

Func key_asp43()
	SendKeyCode(227)
EndFunc

Func key_asp169()
	SendKeyCode(228)
EndFunc

Func key_smode()
	SendKeyCode(43)
EndFunc

Func key_pmode()
	SendKeyCode(40)
EndFunc

Func key_dynamic()
	SendKeyCode(189)
EndFunc

Func key_standard()
	SendKeyCode(223)
EndFunc

Func key_movie()
	SendKeyCode(222)
EndFunc

Func key_scart1()
	SendKeyCode(132)
EndFunc

Func key_scart2()
	SendKeyCode(235)
EndFunc

Func key_module()
	SendKeyCode(134)
EndFunc

Func key_av()
	SendKeyCode(236)
EndFunc

Func key_vga()
	SendKeyCode(105)
EndFunc

Func key_hdmi1()
	SendKeyCode(233)
EndFunc

Func key_hdmi2()
	SendKeyCode(190)
EndFunc

Func key_hdmi3()
	SendKeyCode(194)
EndFunc

Func key_hdmi4()
	SendKeyCode(197)
EndFunc

Func key_pip()
	SendKeyCode(32)
EndFunc

Func key_pip1()
	SendKeyCode(520)
	GUICtrlSetState($btn_pip_x, $GUI_ENABLE)
EndFunc

Func key_pip2()
	SendKeyCode(523)
	GUICtrlSetState($btn_pip_x, $GUI_ENABLE)
EndFunc

Func key_dual()
	SendKeyCode(0)
EndFunc

Func key_source_tv()
	SendKeyCode(125)
EndFunc

Func key_source_vcr()
	SendKeyCode(122)
EndFunc

Func key_source_dvd()
	SendKeyCode(126)
EndFunc

Func key_source_stb()
	SendKeyCode(127)
EndFunc

Func key_space()
	SendKeyCode(35)
EndFunc

Func key_wlink()
	SendKeyCode(140)
EndFunc

Func key_infol()
	SendKeyCode(147)
EndFunc

Func key_dma()
	SendKeyCode(99)
EndFunc

Func key_emode()
	SendKeyCode(148)
EndFunc

Func key_power()
	If MsgBox(33, "Power OFF TV", "   Are you sure you want to shutdown TV and close app?") = 1 Then
		SendKeyCode(2)
		end()
	EndIf
EndFunc

Func key_pip_x()
	key_guide()
	Sleep(2000)
	key_return()
	GUICtrlSetState($btn_pip_x, $GUI_DISABLE)
EndFunc

Func key_dvb()
	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_dvb, $GUI_DISABLE)
	If $tv_model = "B650" Then
		key_exit()
		GUICtrlSetState($btn_exit, $GUI_FOCUS)
		GUICtrlSetData($progress, 5)
		Sleep(1000)
		key_tv()
		GUICtrlSetState($btn_tv, $GUI_FOCUS)
		GUICtrlSetData($progress, 10)
		Sleep(2000)
		key_menu()
		GUICtrlSetState($btn_menu, $GUI_FOCUS)
		GUICtrlSetData($progress, 23)
		Sleep(1000)
		key_up()
		GUICtrlSetState($btn_up, $GUI_FOCUS)
		GUICtrlSetData($progress, 36)
		Sleep(1000)
		key_enter()
		GUICtrlSetState($btn_enter, $GUI_FOCUS)
		GUICtrlSetData($progress, 49)
		Sleep(1000)
		key_down()
		GUICtrlSetState($btn_down, $GUI_FOCUS)
		GUICtrlSetData($progress, 62)
		Sleep(1000)
		If $alt_dvb = "1" Then
			key_down()
			GUICtrlSetState($btn_down, $GUI_FOCUS)
			GUICtrlSetData($progress, 68)
			Sleep(1000)
		EndIf
		key_enter()
		GUICtrlSetState($btn_enter, $GUI_FOCUS)
		GUICtrlSetData($progress, 75)
		Sleep(1000)
		key_up()
		GUICtrlSetState($btn_up, $GUI_FOCUS)
		GUICtrlSetData($progress, 88)
		Sleep(1000)
		key_enter()
		GUICtrlSetState($btn_enter, $GUI_FOCUS)
	ElseIf $tv_model = "A956" Then
		key_menu()
		GUICtrlSetState($btn_menu, $GUI_FOCUS)
		GUICtrlSetData($progress, 16)
		Sleep(1000)
		key_down()
		GUICtrlSetState($btn_down, $GUI_FOCUS)
		GUICtrlSetData($progress, 33)
		Sleep(1000)
		key_down()
		GUICtrlSetState($btn_down, $GUI_FOCUS)
		GUICtrlSetData($progress, 50)
		Sleep(1000)
		key_right()
		GUICtrlSetState($btn_right, $GUI_FOCUS)
		GUICtrlSetData($progress, 66)
		Sleep(1000)
		key_up()
		GUICtrlSetState($btn_up, $GUI_FOCUS)
		GUICtrlSetData($progress, 83)
		Sleep(1000)
		key_enter()
		GUICtrlSetState($btn_enter, $GUI_FOCUS)
	EndIf
	GUICtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_dvb, $GUI_ENABLE)
	GUICtrlSetState($btn_dvb, $GUI_FOCUS)
	GUICtrlSetState($btn_dvb, $GUI_HIDE)
	GUICtrlSetState($btn_dvb, $GUI_SHOW)
	GUICtrlSetState($progress, $GUI_HIDE)
	GUICtrlSetData($progress, 0)
EndFunc

Func key_hnc()
	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_hnc, $GUI_DISABLE)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GUICtrlSetData($progress, 5)
	Sleep(1000)
	key_tv()
	GUICtrlSetState($btn_tv, $GUI_FOCUS)
	GUICtrlSetData($progress, 10)
	Sleep(2000)
	key_menu()
	GUICtrlSetState($btn_menu, $GUI_FOCUS)
	GUICtrlSetData($progress, 18)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GUICtrlSetData($progress, 26)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GUICtrlSetData($progress, 34)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 42)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GUICtrlSetData($progress, 50)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 58)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GUICtrlSetData($progress, 66)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 74)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 82)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GUICtrlSetData($progress, 90)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_hnc, $GUI_ENABLE)
	GUICtrlSetState($btn_hnc, $GUI_FOCUS)
	GUICtrlSetState($btn_hnc, $GUI_HIDE)
	GUICtrlSetState($btn_hnc, $GUI_SHOW)
	GUICtrlSetState($progress, $GUI_HIDE)
	GUICtrlSetData($progress, 0)
EndFunc

Func key_spk()
	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_spk, $GUI_DISABLE)
	key_menu()
	GUICtrlSetState($btn_menu, $GUI_FOCUS)
	GUICtrlSetData($progress, 11)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GUICtrlSetData($progress, 22)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 33)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GUICtrlSetData($progress, 44)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GUICtrlSetData($progress, 55)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 66)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GUICtrlSetData($progress, 77)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 88)
	Sleep(1000)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GUICtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_spk, $GUI_ENABLE)
	GUICtrlSetState($btn_spk, $GUI_FOCUS)
	GUICtrlSetState($btn_spk, $GUI_HIDE)
	GUICtrlSetState($btn_spk, $GUI_SHOW)
	GUICtrlSetState($progress, $GUI_HIDE)
	GUICtrlSetData($progress, 0)
EndFunc

Func key_user1()
	SendKeyCode($user_btn_keycode1)
EndFunc

Func key_user2()
	SendKeyCode($user_btn_keycode2)
EndFunc

Func key_user_seq()
	$user_btn_key1_get = GUICtrlRead($user_btn_key1_input)
	$user_btn_key2_get = GUICtrlRead($user_btn_key2_input)
	$user_btn_key3_get = GUICtrlRead($user_btn_key3_input)
	$user_btn_key4_get = GUICtrlRead($user_btn_key4_input)
	$user_btn_key5_get = GUICtrlRead($user_btn_key5_input)
	$user_btn_key6_get = GUICtrlRead($user_btn_key6_input)
	$user_btn_key7_get = GUICtrlRead($user_btn_key7_input)
	$user_btn_key8_get = GUICtrlRead($user_btn_key8_input)
	$user_btn_key9_get = GUICtrlRead($user_btn_key9_input)
	$user_btn_key0_get = GUICtrlRead($user_btn_key0_input)

	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_user_seq, $GUI_DISABLE)
	if $user_btn_key1_get <> "" Then
		GUICtrlSetData($progress, 5)
		If $user_btn_key1_get <> "-" Then
			SendKeyCode($user_btn_key1_get)
			Sleep(1000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 10)
	if $user_btn_key2_get <> "" Then
		GUICtrlSetData($progress, 15)
		If $user_btn_key2_get <> "-" Then
			SendKeyCode($user_btn_key2_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 20)
	if $user_btn_key3_get <> "" Then
		GUICtrlSetData($progress, 25)
		If $user_btn_key3_get <> "-" Then
			SendKeyCode($user_btn_key3_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 30)
	if $user_btn_key4_get <> "" Then
		GUICtrlSetData($progress, 35)
		If $user_btn_key4_get <> "-" Then
			SendKeyCode($user_btn_key4_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 40)
	if $user_btn_key5_get <> "" Then
		GUICtrlSetData($progress, 45)
		If $user_btn_key5_get <> "-" Then
			SendKeyCode($user_btn_key5_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 50)
	if $user_btn_key6_get <> "" Then
		GUICtrlSetData($progress, 55)
		If $user_btn_key6_get <> "-" Then
			SendKeyCode($user_btn_key6_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 60)
	if $user_btn_key7_get <> "" Then
		GUICtrlSetData($progress, 65)
		If $user_btn_key7_get <> "-" Then
			SendKeyCode($user_btn_key7_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 70)
	if $user_btn_key8_get <> "" Then
		GUICtrlSetData($progress, 75)
		If $user_btn_key8_get <> "-" Then
			SendKeyCode($user_btn_key8_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 80)
	if $user_btn_key9_get <> "" Then
		GUICtrlSetData($progress, 85)
		If $user_btn_key9_get <> "-" Then
			SendKeyCode($user_btn_key9_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GUICtrlSetData($progress, 90)
	if $user_btn_key0_get <> "" Then
		GUICtrlSetData($progress, 95)
		SendKeyCode($user_btn_key0_get)
	EndIf
	GUICtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_user_seq, $GUI_ENABLE)
	GUICtrlSetState($progress, $GUI_HIDE)
	GUICtrlSetData($progress, 0)
EndFunc

Func btn_test_send()
	$test_keycode_get = GUICtrlRead($input_test)
	If $test_keycode_get <> "" Then SendKeyCode($test_keycode_get)
EndFunc

Func run_app1()
	run_cl(1)
	If $app1_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app1, $GUI_CHECKED)
		GUICtrlSetState($menu_app1, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app2()
	run_cl(2)
	If $app2_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app2, $GUI_CHECKED)
		GUICtrlSetState($menu_app2, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app3()
	run_cl(3)
	If $app3_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app3, $GUI_CHECKED)
		GUICtrlSetState($menu_app3, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app4()
	run_cl(4)
	If $app4_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app4, $GUI_CHECKED)
		GUICtrlSetState($menu_app4, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app5()
	run_cl(5)
	If $app5_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app5, $GUI_CHECKED)
		GUICtrlSetState($menu_app5, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app6()
	run_cl(6)
	If $app6_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app6, $GUI_CHECKED)
		GUICtrlSetState($menu_app6, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app7()
	run_cl(7)
	If $app7_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app7, $GUI_CHECKED)
		GUICtrlSetState($menu_app7, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app8()
	run_cl(8)
	If $app8_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app8, $GUI_CHECKED)
		GUICtrlSetState($menu_app8, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app9()
	run_cl(9)
	If $app9_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app9, $GUI_CHECKED)
		GUICtrlSetState($menu_app9, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_app10()
	run_cl(10)
	If $app10_x = "1" Then
		exit_cl()
		GUICtrlSetState($menu_app10, $GUI_CHECKED)
		GUICtrlSetState($menu_app10, $GUI_DISABLE)
	EndIf
	run_cl_end()
EndFunc

Func run_cl($app_id)
	GUICtrlSetState($progress, $GUI_SHOW)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GUICtrlSetData($progress, 10)
	sleep(3000)
	key_content()
	GUICtrlSetState($btn_content, $GUI_FOCUS)
	GUICtrlSetData($progress, 20)
	sleep(5000)
	If $app_cl_new = "1" Then
		key_8()
		GUICtrlSetState($btn_8, $GUI_FOCUS)
	Else
		key_left()
		GUICtrlSetState($btn_left, $GUI_FOCUS)
		GUICtrlSetData($progress, 25)
		sleep(2000)
		key_enter()
		GUICtrlSetState($btn_enter, $GUI_FOCUS)
	EndIf
	GUICtrlSetData($progress, 30)
	sleep(2000)
	key_right()
	GUICtrlSetState($btn_right, $GUI_FOCUS)
	GUICtrlSetData($progress, 40)
	sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GUICtrlSetData($progress, 50)
	sleep(750)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GUICtrlSetData($progress, 60)
	sleep(750)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GUICtrlSetData($progress, 80)
	sleep(1000)
	$i = 0
	Do
		$i = $i + 1
		key_down()
		GUICtrlSetState($btn_down, $GUI_FOCUS)
		sleep(1000)
	Until $i = $app_id
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
EndFunc

Func run_cl_end()
	GUICtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($progress, $GUI_HIDE)
	GUICtrlSetData($progress, 0)
EndFunc

Func exit_cl()
	sleep(5000)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GUICtrlSetData($progress, 95)
	sleep(5000)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
EndFunc

Func upnp_devices_list()
	; more info: http://msdn2.microsoft.com/en-us/library/aa382297.aspx
	Dim $deviceFinder, $DeviceType, $Devices, $Device, $strDescDocURL
	$DeviceFinder = ObjCreate( "UPnP.UPnPDeviceFinder" )
	$DeviceServices = ObjCreate( "UPnP.UPnPServices" )
	$DeviceService = ObjCreate( "UPnP.UPnPService" )
	$Device = ObjCreate( "UPnP.UPnPDevice" )
	$DeviceType = "upnp:rootdevice"
	$Devices = $DeviceFinder.FindByType($DeviceType,0)
	$upnp_i = 0
	For $DeviceObj in $Devices
		$upnp_i = $upnp_i+1
		$upnp_SerialNumber = $deviceObj.SerialNumber
		$upnp_PresentationURL = $deviceObj.PresentationURL
		if $deviceObj.SerialNumber = "0" then  $upnp_SerialNumber = "?"
		if $deviceObj.PresentationURL = "0" then $upnp_PresentationURL = "?"
		MsgBox(8256, "UPnP Device " & $upnp_i & "/" & $Devices.Count, "  Device name:  " & $deviceObj.ModelName & @CRLF & _
		"  Friendly name:  " & $deviceObj.FriendlyName & @CRLF & _
		"  Description:  " & $deviceObj.Description & @CRLF & _
		"  Manufacturer:  " & $deviceObj.ManufacturerName & @CRLF & _
		"  URL:  " & $deviceObj.ManufacturerURL & @CRLF & _
		"  Serial Number:  " & $upnp_SerialNumber & @CRLF & _
		"  ID:  " & $deviceObj.UniqueDeviceName & @CRLF & _
		"  Type:  " & $deviceObj.Type & @CRLF & _
		"  IP:  " & $upnp_PresentationURL & @CRLF)
	next
EndFunc

Func SendKeycode($keycode)
	Local $sc
	TCPStartup()
	While 1
		$sc = TCPConnect($tv_ip, 2345)
		If @error Then
			If MsgBox(17, "Error - " & @error, "   TCPConnect failed with WSA error: " & @error & @CRLF & @CRLF & "   Click 'Cancel' button to exit application.") = 2 Then end()
			ExitLoop
		EndIf
		TCPSend($sc, $keycode & @LF)
		TCPCloseSocket($sc)
		ExitLoop
	WEnd
	TCPShutdown()
EndFunc

Func soap_refresh()
	get_soap("GetVolume", "CurrentVolume", "<Channel>Master</Channel>")
	GUICtrlSetData($input_soap_volume, $objReturn.Text)
	GUICtrlSetData($slider_soap_volume, $objReturn.Text)

	get_soap("GetBrightness", "CurrentBrightness", "")
	GUICtrlSetData($input_soap_brightness, $objReturn.Text)
	GUICtrlSetData($slider_soap_brightness, $objReturn.Text)

	get_soap("GetContrast", "CurrentContrast", "")
	GUICtrlSetData($input_soap_contrast, $objReturn.Text)
	GUICtrlSetData($slider_soap_contrast, $objReturn.Text)

	get_soap("GetSharpness", "CurrentSharpness", "")
	GUICtrlSetData($input_soap_sharpness, $objReturn.Text)
	GUICtrlSetData($slider_soap_sharpness, $objReturn.Text)

	get_soap("GetColorTemperature", "CurrentColorTemperature", "")
	GUICtrlSetData($input_soap_colortemp, $objReturn.Text)
	If $objReturn.Text = "2" Then
		GUICtrlSetData($dd_soap_colortemp, "Cool")
	ElseIf $objReturn.Text = "3" Then
		GUICtrlSetData($dd_soap_colortemp, "Normal")
	ElseIf $objReturn.Text = "4" Then
		GUICtrlSetData($dd_soap_colortemp, "Warm1")
	ElseIf $objReturn.Text = "5" Then
		GUICtrlSetData($dd_soap_colortemp, "Warm2")
	ElseIf $objReturn.Text = "6" Then
		GUICtrlSetData($dd_soap_colortemp, "Warm3")
	EndIf

	get_soap("GetMute", "CurrentMute", "<Channel>Master</Channel>")
	If $objReturn.Text = "1" Then
		GUICtrlSetState($lbl_soap_volume_mute, $GUI_SHOW)
		GUICtrlSetData($btn_soap_volume_mute, "Unmute")
	ElseIf $objReturn.Text = "0" Then
		GUICtrlSetState($lbl_soap_volume_mute, $GUI_HIDE)
		GUICtrlSetData($btn_soap_volume_mute, "Mute")
	EndIf
EndFunc

Func soap_volume_mute()
	$btn_soap_volume_mute_get = GUICtrlRead($btn_soap_volume_mute)
	If $btn_soap_volume_mute_get = "Mute" Then
		send_soap("SetMute", "DesiredMute", "<Channel>Master</Channel>", "1")
	ElseIf $btn_soap_volume_mute_get = "Unmute" Then
		send_soap("SetMute", "DesiredMute", "<Channel>Master</Channel>", "0")
	EndIf
	soap_refresh()
EndFunc

Func soap_set_all()
	$input_soap_volume_get = GUICtrlRead($input_soap_volume)
	If $input_soap_volume_get <> "" Then send_soap("SetVolume", "DesiredVolume", "<Channel>Master</Channel>", $input_soap_volume_get)
	$input_soap_brightness_get = GUICtrlRead($input_soap_brightness)
	If $input_soap_brightness_get <> "" Then send_soap("SetBrightness", "DesiredBrightness", "", $input_soap_brightness_get)
	$input_soap_contrast_get = GUICtrlRead($input_soap_contrast)
	If $input_soap_contrast_get <> "" Then send_soap("SetContrast", "DesiredContrast", "", $input_soap_contrast_get)
	$input_soap_sharpness_get = GUICtrlRead($input_soap_sharpness)
	If $input_soap_sharpness_get <> "" Then send_soap("SetSharpness", "DesiredSharpness", "", $input_soap_sharpness_get)
	soap_set_colortemp()
EndFunc

Func soap_set_volume()
	$input_soap_volume_get = GUICtrlRead($input_soap_volume)
	If $input_soap_volume_get <> "" Then send_soap("SetVolume", "DesiredVolume", "<Channel>Master</Channel>", $input_soap_volume_get)
	soap_refresh()
EndFunc

Func soap_set_brightness()
	$input_soap_brightness_get = GUICtrlRead($input_soap_brightness)
	If $input_soap_brightness_get <> "" Then send_soap("SetBrightness", "DesiredBrightness", "", $input_soap_brightness_get)
	soap_refresh()
EndFunc

Func soap_set_contrast()
	$input_soap_contrast_get = GUICtrlRead($input_soap_contrast)
	If $input_soap_contrast_get <> "" Then send_soap("SetContrast", "DesiredContrast", "", $input_soap_contrast_get)
	soap_refresh()
EndFunc

Func soap_set_sharpness()
	$input_soap_sharpness_get = GUICtrlRead($input_soap_sharpness)
	If $input_soap_sharpness_get <> "" Then send_soap("SetSharpness", "DesiredSharpness", "", $input_soap_sharpness_get)
	soap_refresh()
EndFunc

Func soap_set_colortemp()
	$soap_colortemp_get = "0"
	If GUICtrlRead($dd_soap_colortemp) = "Cool" Then
		$soap_colortemp_get = "2"
	ElseIf GUICtrlRead($dd_soap_colortemp) = "Normal" Then
		$soap_colortemp_get = "3"
	ElseIf GUICtrlRead($dd_soap_colortemp) = "Warm1" Then
		$soap_colortemp_get = "4"
	ElseIf GUICtrlRead($dd_soap_colortemp) = "Warm2" Then
		$soap_colortemp_get = "5"
	ElseIf GUICtrlRead($dd_soap_colortemp) = "Warm3" Then
		$soap_colortemp_get = "6"
	EndIf
	send_soap("SetColorTemperature", "DesiredColorTemperature", "", $soap_colortemp_get)
	soap_refresh()
EndFunc

Func get_soap($soap_action, $soap_argument, $soap_argument_full)
	; app hang and exit while use bellow error check
	; $oMyError = ObjEvent("AutoIt.Error","error_soap")
	Dim $soap_return = "1"
	$objHTTP = ObjCreate("Microsoft.XMLHTTP")
	$objReturn = ObjCreate("Msxml2.DOMDocument.3.0")
	$strEnvelope = "<?xml version='1.0' encoding='utf-8'?><s:Envelope s:encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' xmlns:s='http://schemas.xmlsoap.org/soap/envelope/'><s:Body>" & _
		"<ns0:" & $soap_action & " xmlns:ns0='urn:schemas-upnp-org:service:RenderingControl:1'><" & $soap_argument & "></" & $soap_argument & "><InstanceID>0</InstanceID>" & $soap_argument_full & _
		"</ns0:" & $soap_action & "></s:Body></s:Envelope>"
	$objHTTP.open("post", "http://" & $tv_ip & ":52235/upnp/control/RenderingControl1", False)
	$objHTTP.setRequestHeader("Content-Type", "text/xml")
	$objHTTP.setRequestHeader("SoapAction", "urn:schemas-upnp-org:service:RenderingControl:1#" & $soap_action)
	$objHTTP.send($strEnvelope)
	$strReturn = $objHTTP.responseText
	$objReturn.loadXML($strReturn)
	$strQuery = "s:Envelope/s:Body/ns0:" & $soap_action & "/" & $soap_argument
	$dblTax = $objReturn.selectSingleNode($strQuery)
	Return $objReturn.Text
EndFunc

Func send_soap($soap_action, $soap_argument, $soap_argument_full, $soap_send)
	; $oMyError = ObjEvent("AutoIt.Error","error_soap")
	$objHTTP = ObjCreate("Microsoft.XMLHTTP")
	$objReturn = ObjCreate("Msxml2.DOMDocument.3.0")
	$strEnvelope = "<?xml version='1.0' encoding='utf-8'?><s:Envelope s:encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' xmlns:s='http://schemas.xmlsoap.org/soap/envelope/'><s:Body>" & _
		"<ns0:" & $soap_action & " xmlns:ns0='urn:schemas-upnp-org:service:RenderingControl:1'><" & $soap_argument & ">" & $soap_send & "</" & $soap_argument & "><InstanceID>0</InstanceID>" & $soap_argument_full & _
		"</ns0:" & $soap_action & "></s:Body></s:Envelope>"
	$objHTTP.open("post", "http://" & $tv_ip & ":52235/upnp/control/RenderingControl1", False)
	$objHTTP.setRequestHeader("Content-Type", "text/xml")
	$objHTTP.setRequestHeader("SoapAction", "urn:schemas-upnp-org:service:RenderingControl:1#" & $soap_action)
	$objHTTP.send($strEnvelope)
EndFunc

Func error_soap()
	If Msgbox(17,"Error - SOAP/UPnP send", "Error while send request." &  @CRLF & @CRLF & "Click 'Cancel' button to exit application.") = 2 Then Exit
EndFunc

Func save_config()
	$tv_ip_get = _GUICtrlIpAddress_Get($tv_ip_input)
	IniWrite($config, "connect", "ip", $tv_ip_get)

	If GUICtrlRead($tv_model_b650) = $GUI_CHECKED Then
		$tv_model_get = "B650"
	ElseIf GUICtrlRead($tv_model_b6000) = $GUI_CHECKED Then
		$tv_model_get = "B6000"
	ElseIf GUICtrlRead($tv_model_a956) = $GUI_CHECKED Then
		$tv_model_get = "A956"
	ElseIf GUICtrlRead($tv_model_soap) = $GUI_CHECKED Then
		$tv_model_get = "SOAP"
	EndIf
	IniWrite($config, "model", "tv", $tv_model_get)

	If GUICtrlRead($tv_remote_list) = "BN59-00938A" Then
		$tv_remote_get = "938"
	ElseIf GUICtrlRead($tv_remote_list) = "BN59-00861A" Then
		$tv_remote_get = "861"
	EndIf
	IniWrite($config, "model", "rc", $tv_remote_get)

	$source_scart1_get = GUICtrlRead($source_scart1_input)
	IniWrite($config, "direct source", "scart1", $source_scart1_get)
	$source_scart2_get = GUICtrlRead($source_scart2_input)
	IniWrite($config, "direct source", "scart2", $source_scart2_get)
	$source_module_get = GUICtrlRead($source_module_input)
	IniWrite($config, "direct source", "module", $source_module_get)
	$source_av_get = GUICtrlRead($source_av_input)
	IniWrite($config, "direct source", "av", $source_av_get)
	$source_vga_get = GUICtrlRead($source_vga_input)
	IniWrite($config, "direct source", "vga", $source_vga_get)
	$source_hdmi1_get = GUICtrlRead($source_hdmi1_input)
	IniWrite($config, "direct source", "hdmi1", $source_hdmi1_get)
	$source_hdmi2_get = GUICtrlRead($source_hdmi2_input)
	IniWrite($config, "direct source", "hdmi2", $source_hdmi2_get)
	$source_hdmi3_get = GUICtrlRead($source_hdmi3_input)
	IniWrite($config, "direct source", "hdmi3", $source_hdmi3_get)
	$source_hdmi4_get = GUICtrlRead($source_hdmi4_input)
	IniWrite($config, "direct source", "hdmi4", $source_hdmi4_get)

	$user_button_get = "0"
	If GUICtrlRead($user_button_active1) = $GUI_CHECKED Then $user_button_get = "1"
	If GUICtrlRead($user_button_active1) = $GUI_CHECKED And GUICtrlRead($user_button_active2) = $GUI_CHECKED Then $user_button_get = "2"
	IniWrite($config, "user button", "active", $user_button_get)

	$user_box_name_get = GUICtrlRead($user_box_name_input)
	IniWrite($config, "user button", "box name", $user_box_name_get)

	$user_btn_name1_get = GUICtrlRead($user_btn_name1_input)
	IniWrite($config, "user button", "name1", $user_btn_name1_get)

	$user_btn_keycode1_get = GUICtrlRead($user_btn_keycode1_input)
	IniWrite($config, "user button", "keycode1", $user_btn_keycode1_get)

	$user_btn_name2_get = GUICtrlRead($user_btn_name2_input)
	IniWrite($config, "user button", "name2", $user_btn_name2_get)

	$user_btn_keycode2_get = GUICtrlRead($user_btn_keycode2_input)
	IniWrite($config, "user button", "keycode2", $user_btn_keycode2_get)

	If GUICtrlRead($user_btn_seq_active) = $GUI_CHECKED Then
		$user_btn_seq_get = "1"
	Else
		$user_btn_seq_get = "0"
	EndIf
	IniWrite($config, "user button", "seq", $user_btn_seq_get)

	$user_btn_name_get = GUICtrlRead($user_btn_name_input)
	IniWrite($config, "user button", "name", $user_btn_name_get)
	$user_btn_key1_get = GUICtrlRead($user_btn_key1_input)
	IniWrite($config, "user button", "key1", $user_btn_key1_get)
	$user_btn_key2_get = GUICtrlRead($user_btn_key2_input)
	IniWrite($config, "user button", "key2", $user_btn_key2_get)
	$user_btn_key3_get = GUICtrlRead($user_btn_key3_input)
	IniWrite($config, "user button", "key3", $user_btn_key3_get)
	$user_btn_key4_get = GUICtrlRead($user_btn_key4_input)
	IniWrite($config, "user button", "key4", $user_btn_key4_get)
	$user_btn_key5_get = GUICtrlRead($user_btn_key5_input)
	IniWrite($config, "user button", "key5", $user_btn_key5_get)
	$user_btn_key6_get = GUICtrlRead($user_btn_key6_input)
	IniWrite($config, "user button", "key6", $user_btn_key6_get)
	$user_btn_key7_get = GUICtrlRead($user_btn_key7_input)
	IniWrite($config, "user button", "key7", $user_btn_key7_get)
	$user_btn_key8_get = GUICtrlRead($user_btn_key8_input)
	IniWrite($config, "user button", "key8", $user_btn_key8_get)
	$user_btn_key9_get = GUICtrlRead($user_btn_key9_input)
	IniWrite($config, "user button", "key9", $user_btn_key9_get)
	$user_btn_key0_get = GUICtrlRead($user_btn_key0_input)
	IniWrite($config, "user button", "key0", $user_btn_key0_get)

	If GUICtrlRead($hotkeys_numeric_active) = $GUI_CHECKED Then
		$hotkeys_numeric_get = "1"
	Else
		$hotkeys_numeric_get = "0"
	EndIf
	IniWrite($config, "hotkeys", "numeric", $hotkeys_numeric_get)

	If GUICtrlRead($hotkeys_arrows_active) = $GUI_CHECKED Then
		$hotkeys_arrows_get = "1"
	Else
		$hotkeys_arrows_get = "0"
	EndIf
	IniWrite($config, "hotkeys", "arrows", $hotkeys_arrows_get)

	If GUICtrlRead($hotkeys_media_active) = $GUI_CHECKED Then
		$hotkeys_media_get = "1"
	Else
		$hotkeys_media_get = "0"
	EndIf
	IniWrite($config, "hotkeys", "media", $hotkeys_media_get)

	If GUICtrlRead($app_cl_active) = $GUI_CHECKED Then
		$app_cl_get = "1"
	Else
		$app_cl_get = "0"
	EndIf
	IniWrite($config, "content library", "active", $app_cl_get)

	If GUICtrlRead($app_cl_new_active) = $GUI_CHECKED Then
		$app_cl_new_get = "1"
	Else
		$app_cl_new_get = "0"
	EndIf
	IniWrite($config, "content library", "unofficial", $app_cl_new_get)

	$app1_get = GUICtrlRead($app1_input)
	IniWrite($config, "content library", "app1", $app1_get)
	If GUICtrlRead($app1_a_active) = $GUI_CHECKED Then
		$app1_a_get = "1"
	Else
		$app1_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app1_a", $app1_a_get)
	If GUICtrlRead($app1_x_active) = $GUI_CHECKED Then
		$app1_x_get = "1"
	Else
		$app1_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app1_x", $app1_x_get)

	$app2_get = GUICtrlRead($app2_input)
	IniWrite($config, "content library", "app2", $app2_get)
	If GUICtrlRead($app2_a_active) = $GUI_CHECKED Then
		$app2_a_get = "1"
	Else
		$app2_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app2_a", $app2_a_get)
	If GUICtrlRead($app2_x_active) = $GUI_CHECKED Then
		$app2_x_get = "1"
	Else
		$app2_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app2_x", $app2_x_get)

	$app3_get = GUICtrlRead($app3_input)
	IniWrite($config, "content library", "app3", $app3_get)
	If GUICtrlRead($app3_a_active) = $GUI_CHECKED Then
		$app3_a_get = "1"
	Else
		$app3_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app3_a", $app3_a_get)
	If GUICtrlRead($app3_x_active) = $GUI_CHECKED Then
		$app3_x_get = "1"
	Else
		$app3_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app3_x", $app3_x_get)

	$app4_get = GUICtrlRead($app4_input)
	IniWrite($config, "content library", "app4", $app4_get)
	If GUICtrlRead($app4_a_active) = $GUI_CHECKED Then
		$app4_a_get = "1"
	Else
		$app4_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app4_a", $app4_a_get)
	If GUICtrlRead($app4_x_active) = $GUI_CHECKED Then
		$app4_x_get = "1"
	Else
		$app4_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app4_x", $app4_x_get)

	$app5_get = GUICtrlRead($app5_input)
	IniWrite($config, "content library", "app5", $app5_get)
	If GUICtrlRead($app5_a_active) = $GUI_CHECKED Then
		$app5_a_get = "1"
	Else
		$app5_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app5_a", $app5_a_get)
	If GUICtrlRead($app5_x_active) = $GUI_CHECKED Then
		$app5_x_get = "1"
	Else
		$app5_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app5_x", $app5_x_get)

	$app6_get = GUICtrlRead($app6_input)
	IniWrite($config, "content library", "app6", $app6_get)
	If GUICtrlRead($app6_a_active) = $GUI_CHECKED Then
		$app6_a_get = "1"
	Else
		$app6_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app6_a", $app6_a_get)
	If GUICtrlRead($app6_x_active) = $GUI_CHECKED Then
		$app6_x_get = "1"
	Else
		$app6_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app6_x", $app6_x_get)

	$app7_get = GUICtrlRead($app7_input)
	IniWrite($config, "content library", "app7", $app7_get)
	If GUICtrlRead($app7_a_active) = $GUI_CHECKED Then
		$app7_a_get = "1"
	Else
		$app7_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app7_a", $app7_a_get)
	If GUICtrlRead($app7_x_active) = $GUI_CHECKED Then
		$app7_x_get = "1"
	Else
		$app7_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app7_x", $app7_x_get)

	$app8_get = GUICtrlRead($app8_input)
	IniWrite($config, "content library", "app8", $app8_get)
	If GUICtrlRead($app8_a_active) = $GUI_CHECKED Then
		$app8_a_get = "1"
	Else
		$app8_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app8_a", $app8_a_get)
	If GUICtrlRead($app8_x_active) = $GUI_CHECKED Then
		$app8_x_get = "1"
	Else
		$app8_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app8_x", $app8_x_get)

	$app9_get = GUICtrlRead($app9_input)
	IniWrite($config, "content library", "app9", $app9_get)
	If GUICtrlRead($app9_a_active) = $GUI_CHECKED Then
		$app9_a_get = "1"
	Else
		$app9_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app9_a", $app9_a_get)
	If GUICtrlRead($app9_x_active) = $GUI_CHECKED Then
		$app9_x_get = "1"
	Else
		$app9_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app9_x", $app9_x_get)

	$app10_get = GUICtrlRead($app10_input)
	IniWrite($config, "content library", "app10", $app10_get)
	If GUICtrlRead($app10_a_active) = $GUI_CHECKED Then
		$app10_a_get = "1"
	Else
		$app10_a_get = "0"
	EndIf
	IniWrite($config, "content library", "app10_a", $app10_a_get)
	If GUICtrlRead($app10_x_active) = $GUI_CHECKED Then
		$app10_x_get = "1"
	Else
		$app10_x_get = "0"
	EndIf
	IniWrite($config, "content library", "app10_x", $app10_x_get)

	If GUICtrlRead($extra_buttons_active) = $GUI_CHECKED Then
		$extra_buttons_get = "1"
	Else
		$extra_buttons_get = "0"
	EndIf
	IniWrite($config, "extra buttons", "visible", $extra_buttons_get)

	If GUICtrlRead($fast_btn_active) = $GUI_CHECKED Then
		$fast_btn_get = "1"
	Else
		$fast_btn_get = "0"
	EndIf
	IniWrite($config, "other", "fast_btn", $fast_btn_get)

	If GUICtrlRead($info_ch_active) = $GUI_CHECKED Then
		$info_ch_get = "1"
	Else
		$info_ch_get = "0"
	EndIf
	IniWrite($config, "other", "info_ch", $info_ch_get)

	If GUICtrlRead($alt_dvb_active) = $GUI_CHECKED Then
		$alt_dvb_get = "1"
	Else
		$alt_dvb_get = "0"
	EndIf
	IniWrite($config, "other", "alt_dvb", $alt_dvb_get)

	If GUICtrlRead($hide_menu_active) = $GUI_CHECKED Then
		$hide_menu_get = "1"
	Else
		$hide_menu_get = "0"
	EndIf
	IniWrite($config, "other", "menu", $hide_menu_get)

	If GUICtrlRead($hide_status_active) = $GUI_CHECKED Then
		$hide_status_get = "1"
	Else
		$hide_status_get = "0"
	EndIf
	IniWrite($config, "other", "status", $hide_status_get)

	If GUICtrlRead($symbols_active) = $GUI_CHECKED Then
		$symbols_get = "1"
	Else
		$symbols_get = "0"
	EndIf
	IniWrite($config, "other", "symbols", $symbols_get)

	If GUICtrlRead($optimize_active) = $GUI_CHECKED Then
		$optimize_get = "1"
	Else
		$optimize_get = "0"
	EndIf
	IniWrite($config, "other", "optimize_mem", $optimize_get)

	GUICtrlSetState($btn_restart_config, $GUI_ENABLE)
	GUICtrlSetState($btn_restart_config, $GUI_FOCUS)
	GUICtrlCreateLabel("App needs to be restarted for apply changes.", 160, 375)
	GUICtrlSetColor(-1, 0xFF0000)
EndFunc

Func _Tab_Switch()
	Local $iCurrTab = GUICtrlRead($Tab)
	If $iCurrTab <> $iLastTab Then
		Switch $iCurrTab
			Case 0
				WinSetState($tv_ip_input, "", @SW_SHOW)
			Case 1
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 2
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 3
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 4
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 5
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 6
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 7
				WinSetState($tv_ip_input, "", @SW_HIDE)
		EndSwitch
		$iLastTab = $iCurrTab
	EndIf
EndFunc

Func config_box()
   $GUI_config = GUISetState(@SW_HIDE)
EndFunc

Func restart()
	_ScriptRestart()
EndFunc

Func end()
	Exit
EndFunc

Func _ReduceMemory($i_PID = -1)		; author wOuter
    If $i_PID <> -1 Then
        Local $ai_Handle = DllCall("kernel32.dll", 'int', 'OpenProcess', 'int', 0x1f0fff, 'int', False, 'int', $i_PID)
        Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', $ai_Handle[0])
        DllCall('kernel32.dll', 'int', 'CloseHandle', 'int', $ai_Handle[0])
    Else
        Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', -1)
    EndIf
    Return $ai_Return[0]
EndFunc